<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class ACalefones extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

	    /*else if (!$this->ion_auth->is_admin())
		{
			redirect('/', 'refresh');
		}  */

        $this->load->model('ACalefonProyecto_model', 'model');
    }


      /*
     * Listar Inscripciones por Usuario -
     */
    function index()
    {
     if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }

       if(!empty($this->input->post('anio'))){
      	$this->session->set_userdata('calefones_index_anio', $this->input->post('anio'));
      }

      $anio = $this->session->userdata('calefones_index_anio');

     	$data['estado_inscripcion'] =  '';
     	$estado = 0;
        if($this->input->post('estado_id') > 0) {
        	$estado = $this->input->post('estado_id');
			$data['estado_inscripcion'] = $estado;
		}

		$data['persona_inscripcion'] =  '';
		$persona=0;
		if($this->input->post('persona_id') > 0) {
			$persona = $this->input->post('persona_id');
			$data['persona_inscripcion'] = $persona;
		}

		$data['localidad_inscripcion'] =  '';
		$localidad=0;
		if($this->input->post('localidad_id') > 0) {
			$localidad = $this->input->post('localidad_id');
			$data['localidad_inscripcion'] = $localidad;
		}

		$data['tareas'] = $this->model->get_administrar_inscripciones($estado, $persona, $localidad, $anio);

     	$this->load->model('Persona_model');
		$data['all_personas'] = $this->Persona_model->get_all_personas();

		$this->load->model('Estado_model');
		$data['all_estados'] = $this->Estado_model->get_all_estados();

		$this->load->model('Localidad_model');
		$data['all_localidades'] = $this->Localidad_model->get_all_localidades();

		$data['index_anio'] = $anio;

        $data['_view'] = 'a_calefones/listado_administrar';
      	$this->load->view('layouts/main',$data);
    }

       /*
     * Listar Inscripciones por Usuario -
     */
    function detalle($inscripcion_id = 0, $anio=2023)
    {
      if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
      // si es usuario administrador listar todas - sino por user_id
     // if ($estado > 0)
    //  {
      $data['inscripcion'] = $this->model->get_inscripcion($inscripcion_id);
      $data['asignacion_estados'] = $this->model->get_all_inscipcion_historial_estados($inscripcion_id);
      $data['alertas'] = $this->model->get_alertas($inscripcion_id);
     // var_dump($data['tareas']);
     // }else {
     // 	$data['tareas'] = array();
     // }


        $data['anio'] =$anio;
      	$data['_view'] = 'a_calefones/detalle';
     	$this->load->view('layouts/main',$data);
    }

     /*
     * Editing a calefones_inscripcion
     */
    function actualizar($id)
    {
       if (!$this->ion_auth->is_admin())
		{
			redirect('/', 'refresh');
		}
        // check if the calefones_inscripcion exists before trying to edit it
        $data['calefones_inscripcion'] = $this->model->get_calefones_inscripcion($id);

        if(isset($data['calefones_inscripcion']['id']))
        {
            $this->load->library('form_validation');

            $this->form_validation->set_rules('localidad_id','Localidad','required');
			$this->form_validation->set_rules('persona_id','Evaluador','required');
			$this->form_validation->set_rules('estado_id','Estado de la Inscripci&oacute;n','required');


            if($this->form_validation->run())
            {
                $params = array(
					'localidad_id' => $this->input->post('localidad_id'),
					'persona_id' => $this->input->post('persona_id'),
					'estado_id' => $this->input->post('estado_id'),
                );

                $this->model->update_calefones_inscripcion($id,$params);
                redirect('ACalefones/index');
            }
            else
            {
				$this->load->model('Localidad_model');
				$data['all_localidades'] = $this->Localidad_model->get_all_localidades();

				$this->load->model('Persona_model');
				$data['all_personas'] = $this->Persona_model->get_all_personas();

				$this->load->model('Estado_model');
				$data['all_estados'] = $this->Estado_model->get_all_estados();

                $data['_view'] = 'a_calefones/actualizar';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }

      /*
     * Editing a calefones_inscripcion
     */
    function evaluador($id)
    {
       if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
        // check if the calefones_inscripcion exists before trying to edit it
        $data['calefones_inscripcion'] = $this->model->get_calefones_inscripcion($id);

        if(isset($data['calefones_inscripcion']['id']))
        {
            $this->load->library('form_validation');
			$this->form_validation->set_rules('persona_id','Evaluador','required');

            if($this->form_validation->run())
            {
                $params = array(
					'persona_id' => $this->input->post('persona_id'),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'estado_id' => 2,
                );

                $historial_estado = array(
					'estado_id' => 2,
					'inscripcion_id' => $id,
					'fecha' => date("Y-m-d"),
					'observaciones' => "",
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
                );

                $this->model->update_calefones_inscripcion($id,$params);
                $this->model->add_historial_estados($historial_estado);
                redirect('ACalefones/detalle/'. $id);
            }
            else
            {

				$this->load->model('Persona_model');
				$data['all_personas'] = $this->Persona_model->get_all_personas();

                $data['_view'] = 'a_calefones/evaluador';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }

     /*
     * Editing a calefones_inscripcion
     */
    function edit_estado($id)
    {
      if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
        // check if the calefones_inscripcion exists before trying to edit it
        $data['calefones_inscripcion'] = $this->model->get_calefones_inscripcion($id);

        if(isset($data['calefones_inscripcion']['id']))
        {
            $this->load->library('form_validation');

           // $this->form_validation->set_rules('localidad_id','Localidad','required');
			//$this->form_validation->set_rules('persona_id','Evaluador','required');
			$this->form_validation->set_rules('fecha','Fecha','required');
			$this->form_validation->set_rules('estado_id','Estado de la Inscripci&oacute;n','required');


            if($this->form_validation->run())
            {
                $params = array(
					'estado_id' => $this->input->post('estado_id'),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					//'ape_nom' => $this->input->post('ape_nom'),
					//'dni' => $this->input->post('dni'),
					//'evaluador_asignado' => $this->input->post('evaluador_asignado'),
					//'estado' => $this->input->post('estado'),
                );

                $historial_estado = array(
					'estado_id' => $this->input->post('estado_id'),
					'inscripcion_id' => $id,
					'fecha' => $this->input->post('fecha'),
					'observaciones' => $this->input->post('observaciones'),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
                );

                $this->model->update_calefones_inscripcion($id,$params);
                $this->model->add_historial_estados($historial_estado);
                redirect('ACalefones/detalle/'.$id);
            }
            else
            {
				$this->load->model('Estado_model');
				$data['all_estados'] = $this->Estado_model->get_all_estados();

                $data['_view'] = 'a_calefones/edit_estado';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }

     /*
     * Nuava Alerta
     */
    function add_alerta($id)
    {
	   if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }

        $inscripcion = $this->model->get_calefones_inscripcion($id);

        if(isset( $inscripcion['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('fecha_alerta','Fecha','required');
			$this->form_validation->set_rules('nota','Nota','required|max_length[150]');
			$this->form_validation->set_rules('detalle','Detalle','max_length[255]');


			if($this->form_validation->run())
            {
                $params = array(
					'calefones_inscripcion_id' => $id,
					'fecha_alerta' => $this->input->post('fecha_alerta'),
					'nota' => $this->input->post('nota'),
					'detalle' => $this->input->post('detalle'),
					'creadopor' => $this->session->userdata('ape_nom'),
					'activo' => 1,
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),

                );

                //$this->Notas_calefon_model->update_notas_calefon($id,$params);
                $this->model->add_alerta($params);
                redirect('ACalefones/detalle/'.$id);
            }
            else
            {

                $data['inscripcionID'] = $id;
                $data['_view'] = 'a_calefones/add_alerta';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }

      /*
     * Nuava Alerta
     */
    function edit_alerta($id)
    {
	   if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }

        $data['alerta'] = $this->model->get_alerta($id);

        if(isset( $data['alerta']['id']))
        {
            $inscripcion_id = $data['alerta']['calefones_inscripcion_id'];
            $this->load->library('form_validation');

			$this->form_validation->set_rules('fecha_alerta','Fecha','required');
			$this->form_validation->set_rules('nota','Nota','required|max_length[150]');
			$this->form_validation->set_rules('detalle','Detalle','max_length[255]');


			if($this->form_validation->run())
            {
                $params = array(
					'fecha_alerta' => $this->input->post('fecha_alerta'),
					'nota' => $this->input->post('nota'),
					'detalle' => $this->input->post('detalle'),
					'creadopor' => $this->session->userdata('ape_nom'),
					'activo' => $this->input->post('activo'),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'update' => date("Y-m-d H:i:s"),

                );

                //$this->Notas_calefon_model->update_notas_calefon($id,$params);
                $this->model->edit_alerta($id, $params);
                redirect('ACalefones/detalle/'.$inscripcion_id);
            }
            else
            {
                $data['_view'] = 'a_calefones/edit_alerta';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }

      /*
     * Editing a calefones_inscripcion
     */
    function actualizar_datos($id)
    {
        if (!$this->ion_auth->in_group('calefones_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the calefones_inscripcion exists before trying to edit it
        $data['calefones_inscripcion'] = $this->model->get_calefones_inscripcion_all_datos($id);

        if(isset($data['calefones_inscripcion']['id']))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('email','Email','required|valid_email');
            $this->form_validation->set_rules('ape_nom','Nombre y Apellido','required');
            $this->form_validation->set_rules('dni','DNI','required');
            $this->form_validation->set_rules('grupo_familiar','Grupo Familiar','required');
            $this->form_validation->set_rules('telefono','Tel&eacute;fono','required');
            $this->form_validation->set_rules('domicilio','Domicilio','required');
            $this->form_validation->set_rules('registro_propiedad','Registro Propiedad','required');
            $this->form_validation->set_rules('zona_vivienda','Zona Vivienda','required');
            $this->form_validation->set_rules('servicios_publicos_zona','Servicios P&uacute;blicos','required');
            $this->form_validation->set_rules('material_vivienda','Material Vivienda','required');
            $this->form_validation->set_rules('fuente_ingresos','Fuente Ingresos','required');
            $this->form_validation->set_rules('ingresos_familiar','Ingresos Familiar','required');
            $this->form_validation->set_rules('nom_ape_garante','Nombre y Apellido del Garante','required');
            $this->form_validation->set_rules('dni_garante','DNI del Garante','required');
            $this->form_validation->set_rules('estado_civil_garante','Estado Civil del Garante','required');
            $this->form_validation->set_rules('domicilio_garante','Domicilio del Garante','required');
            $this->form_validation->set_rules('localidad_garante','Localidad del Garante','required');
            $this->form_validation->set_rules('lugar_trabajo_garante','Lugar de Trabajo del Garante','required');
            $this->form_validation->set_rules('ingresos_garante','Ingresos del Garante','required');

            if($this->form_validation->run())
            {
                 $params = array(
                  	'email' => $this->input->post('email'),
                  	'ape_nom' => $this->input->post('ape_nom'),
                  	'dni' => $this->input->post('dni'),
                  	'cuit' => $this->input->post('cuit'),
                  	'estado_civil' => $this->input->post('estado_civil'),
                  	'grupo_familiar' => $this->input->post('grupo_familiar'),
                  	'telefono' => $this->input->post('telefono'),
                  	'domicilio' => $this->input->post('domicilio'),
                 	'registro_propiedad' => $this->input->post('registro_propiedad'),
                  	'zona_vivienda' => $this->input->post('zona_vivienda'),
                  	'servicios_publicos_zona' => $this->input->post('servicios_publicos_zona'),
                  	'material_vivienda' => $this->input->post('material_vivienda'),
                  	'fuente_ingresos' => $this->input->post('fuente_ingresos'),
                  	'ingresos_familiar' => $this->input->post('ingresos_familiar'),
                  	'nom_ape_garante' => $this->input->post('nom_ape_garante'),
                  	'dni_garante' => $this->input->post('dni_garante'),
                  	'estado_civil_garante' => $this->input->post('estado_civil_garante'),
                  	'domicilio_garante' => $this->input->post('domicilio_garante'),
                  	'localidad_garante' => $this->input->post('localidad_garante'),
                  	'lugar_trabajo_garante' => $this->input->post('lugar_trabajo_garante'),
                  	'ingresos_garante' => $this->input->post('ingresos_garante'),
                  	'tel_garante' => $this->input->post('tel_garante'),
                  	'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
                  	);

                $this->model->update_calefones_inscripcion($id,$params);
                 redirect('ACalefones/detalle/'.$id);
            }
            else
            {
                $data['_view'] = 'a_calefones/actualizar_datos';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
         	$this->session->set_flashdata('error', 'La Inscripci&oacute;n que est&aacute;s intentando acceder no existe o no tienes los permisos para su acceso.');
            redirect('ACalefones');
        }
    }



}
