<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Calefones extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('CalefonProyecto_model');
    }

    function index($anio=2023)
    {
    	$estados = $this->CalefonProyecto_model->get_cant_estados($anio);
       $total= 0;
    	 foreach($estados as $e)
        {
           $total += $e['cantidad'];
        }

      //  $evaluadores = $this->CalefonProyecto_model->get_cant_evaluadores_estados();

        $data = $this->CalefonProyecto_model->get_cant_calefones_estados($anio);

        $talabels = $tasinverificacion   = $taverificacion  = $tarechazados = $taaprobados = $tafactibilidad = $tainforme_evaluador =  $tainicio_expediente = '';
        foreach($data as $e)
        {
           $talabels        .= '"'.$e['nom_ape'].'",';
           $tasinverificacion  .= $e['sinasignar']. ',';
           $taverificacion  .= $e['verificacion']. ',';
           $tarechazados   .= $e['rechazados']. ',';
           $taaprobados  .= $e['aprobados']. ',';
           $tafactibilidad  .= $e['factibilidad']. ',';
           $tainforme_evaluador  .= $e['informe_evaluador']. ',';
           $tainicio_expediente  .= $e['inicio_expediente']. ',';
        }

        $data['talabels']  = $talabels;
        $data['tasinverificacion']  = $tasinverificacion;
        $data['taverificacion']  = $taverificacion;
        $data['tarechazados']  = $tarechazados;
        $data['taaprobados']  = $taaprobados;
        $data['tafactibilidad']  = $tafactibilidad;
        $data['tainforme_evaluador']  = $tainforme_evaluador;
        $data['tainicio_expediente']  = $tainicio_expediente;

        $data['estados'] = $estados;
        $data['total_inscriptos'] =$total;
        $data['anio'] =$anio;

        //Calefones Resumen - Listar por Localidad

        $localidades = $this->CalefonProyecto_model->get_cant_calefones_estados_localidad($anio);
        $loclabels = $locsinasignar   = $locverificacion  = $locrechazados = $locaprobados = $locfactibilidad = $locinforme_evaluador =  $locinicio_expediente = '';
        foreach($localidades as $loc)
        {
           $loclabels        .= '"'.$loc['localidad'].'",';
           $locsinasignar  .= $loc['sinasignar']. ',';
           $locverificacion  .= $loc['verificacion']. ',';
           $locrechazados   .= $loc['rechazados']. ',';
           $locaprobados  .= $loc['aprobados']. ',';
           $locfactibilidad  .= $loc['factibilidad']. ',';
           $locinforme_evaluador  .= $loc['informe_evaluador']. ',';
           $locinicio_expediente  .= $loc['inicio_expediente']. ',';
        }

        $data['loclabels']  = $loclabels;
        $data['locsinasignar']  = $locsinasignar ;
        $data['locverificacion']  = $locverificacion;
        $data['locrechazados']  = $locrechazados;
        $data['locaprobados']  = $locaprobados;
        $data['locfactibilidad']  = $locfactibilidad;
        $data['locinforme_evaluador']  = $locinforme_evaluador;
        $data['locinicio_expediente']  = $locinicio_expediente;

        $data['localidades']  = $localidades;


       // $data['evaluadores'] = $evaluadores;

        $data['_view'] = 'calefones/calefonesv2';
        $this->load->view('layouts/main',$data);
    }
      /*
     * Listar Todas las Inscripciones
     */
    function incripciones($anio=2023)
    {
        $data['estado_inscripcion'] =  '';
     	$estado = 0;
        if($this->input->post('estado_id') > 0) {
        	$estado = $this->input->post('estado_id');
			$data['estado_inscripcion'] = $estado;
		}

		$data['persona_inscripcion'] =  '';
		$persona=0;
		if($this->input->post('persona_id') > 0) {
			$persona = $this->input->post('persona_id');
			$data['persona_inscripcion'] = $persona;
		}

		//$data['tareas'] = $this->model->get_administrar_inscripciones($estado, $persona);

        $data['tareas'] = $this->CalefonProyecto_model->get_all_inscripciones($estado, $persona, $anio);

         $data['anio'] =$anio;

        $this->load->model('Persona_model');
		$data['all_personas'] = $this->Persona_model->get_all_personas();

		$this->load->model('Estado_model');
		$data['all_estados'] = $this->Estado_model->get_all_estados();

        $data['_view'] = 'calefones/incripciones_all';
      	$this->load->view('layouts/main',$data);
    }

     /*
     * Listar Inscripciones por Estados
     */
     function listado($estado = 0, $anio=2023)
    {
    	$data['persona_inscripcion'] =  '';
		$persona=0;
		if($this->input->post('persona_id') > 0) {
			$persona = $this->input->post('persona_id');
			$data['persona_inscripcion'] = $persona;
		}

    	$data['tareas'] = $this->CalefonProyecto_model->get_all_inscripciones($estado, $persona, $anio);

        $this->load->model('Persona_model');
		$data['all_personas'] = $this->Persona_model->get_all_personas();
        $data['estado'] = $estado;
        $data['anio'] =$anio;

        $data['_view'] = 'calefones/listado';
        $this->load->view('layouts/main',$data);
    }

        /*
     * Listar Inscripciones por Usuario -
     */
    function tdetalle($inscripcion_id = 0, $anio=2023)
    {

      $data['inscripcion'] = $this->CalefonProyecto_model->get_inscripcion($inscripcion_id);
      $data['asignacion_estados'] = $this->CalefonProyecto_model->get_all_inscipcion_historial_estados($inscripcion_id);
      $data['anio'] =$anio;
      $data['_view'] = 'calefones/detalle_all';
      $this->load->view('layouts/main',$data);
    }

         /*
     * Listar Inscripciones por Usuario -
     */
    function detalle($inscripcion_id = 0, $anio=2023)
    {

      $data['inscripcion'] = $this->CalefonProyecto_model->get_inscripcion($inscripcion_id);
      $data['asignacion_estados'] = $this->CalefonProyecto_model->get_all_inscipcion_historial_estados($inscripcion_id);
      $data['alertas'] = $this->CalefonProyecto_model->get_alertas_inscripcion($inscripcion_id);

      $data['movimientos'] = array();
	  if ($data['inscripcion']['estado_id'] == 7)
	   {
	   	 if ($data['inscripcion']['co_id'] > 0) {
		    $data['movimientos'] =  $this->CalefonProyecto_model->get_movimientos($data['inscripcion']['co_id']);
	   	 }
	   }

       $data['anio'] =$anio;

      $data['_view'] = 'calefones/detalle';
      $this->load->view('layouts/main',$data);
    }

    function alertas()
    {

    	$data['alertas'] = $this->CalefonProyecto_model->get_alertas();
        $data['_view'] = 'calefones/index_alertas';
        $this->load->view('layouts/main',$data);
    }
}
