<?php


class Calefones_credito extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('Calefones_credito_model', 'model');
    }

    /*
     * Listing of estados
     */
    function index()
    {
         if(!empty($this->input->post('anio'))){
      		$this->session->set_userdata('calefones_anio', $this->input->post('anio'));
      	}

      	$anio = $this->session->userdata('calefones_anio');

        $data['calefones_x_anio'] = $anio;
        $data['creditos'] = $this->model->get_all_creditos($anio);
        $data['cant_creditos']= count($data['creditos']);
        $data['pagos'] = $this->model->get_resumen_pagos($anio);
        $data['depositado']= $this->model->get_total_depositado($anio);
        $data['cant_finalizado']= $this->model->get_cantidad_finalizado($anio);



        $data['_view'] = 'calefones_credito/index';
        $this->load->view('layouts/main',$data);
    }

     function detalle($id = 0)
    {
      $data['credito'] = $this->model->get_credito_detalle($id);
      $data['credito_cuotas'] =  $this->model->get_credito_cuotas($id);

      $data['_view'] = 'calefones_credito/detalle';
      $this->load->view('layouts/main',$data);
    }

     /*
     * Listing of estados
     */
    function add_index()
    {
    	if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }

        $data['creditos'] = $this->model->get_agregar_all_creditos();

        $data['_view'] = 'calefones_credito/add_index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new estado
     */
    function add($id)
    {
    	if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }

    	 $data['credito'] = $this->model->get_inscripcion($id);

        if(isset($data['credito']['id']))
        {
	         $this->load->library('form_validation');

          	$this->form_validation->set_rules('fecha_otorgamiento','Fecha','required');
			$this->form_validation->set_rules('monto_otorgamiento','Monto','required|greater_than[0]');
			$this->form_validation->set_rules('cant_meses','Cantidad de Meses','required|greater_than[0]');


            if($this->form_validation->run())
            {
	            $params = array(
	            		'calefones_inscripcion_id' => $id,
						'expediente_nro' => $this->input->post('expediente_nro'),
						'fecha_otorgamiento' => $this->input->post('fecha_otorgamiento'),
						'cant_meses' => $this->input->post('cant_meses'),
						'meses_gracia' => $this->input->post('meses_gracia'),
						'monto_otorgamiento' => $this->input->post('monto_otorgamiento'),
						'anio' => $this->input->post('anio'),
	                );

	            $credito_id = $this->model->add_credito($params);

	            if ($credito_id > 0){
	            	redirect('Calefones_credito/detalle/'.$credito_id);
	         	}else {
	            	redirect('Calefones_credito/index');
	            }
	        }
	        else
	        {
	             $data['all_anios'] = array(array('id'=>(date("Y")-1) , 'anio'=>(date("Y")-1)),
	            				   array('id'=>date("Y") , 'anio'=>date("Y")),
	            				   array('id'=>(date("Y")+1) , 'anio'=>(date("Y")+1))
	            				   );

	            $data['_view'] = 'calefones_credito/add';
	            $this->load->view('layouts/main',$data);
	        }
	     }
	     else
            show_error('Datos NO encontrados.');
    }

    /*
     * Editing a estado
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['credito'] = $this->model->get_credito($id);

        if(isset($data['credito']['id']))
        {
              $this->load->library('form_validation');

          	$this->form_validation->set_rules('fecha_otorgamiento','Fecha','required');
			$this->form_validation->set_rules('monto_otorgamiento','Monto','required|greater_than[0]');
			$this->form_validation->set_rules('cant_meses','Cantidad de Meses','required|greater_than[0]');
			$this->form_validation->set_rules('anio','A&ntilde;o','required|greater_than[0]');


            if($this->form_validation->run())
            {
                $params = array(
					'expediente_nro' => $this->input->post('expediente_nro'),
					'anio' => $this->input->post('anio'),
					'actividad' => $this->input->post('actividad'),
					'fecha_otorgamiento' => $this->input->post('fecha_otorgamiento'),
					'cant_meses' => $this->input->post('cant_meses'),
					'meses_gracia' => $this->input->post('meses_gracia'),
					'monto_otorgamiento' => $this->input->post('monto_otorgamiento'),
                );

                $this->model->update_credito($id,$params);
                redirect('Calefones_credito/detalle/'. $id);
            }
            else
            {
                $data['_view'] = 'calefones_credito/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
            show_error('Datos NO encontrados.');
    }


     function plan_cuotas($id)
    {
    	if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['credito'] = $this->model->get_credito($id);

        if(isset($data['credito']['id']))
        {
        	$this->load->library('form_validation');

          	$this->form_validation->set_rules('fecha_otorgamiento','Fecha','required');
			$this->form_validation->set_rules('monto_otorgamiento','Monto','required|greater_than[0]');
			$this->form_validation->set_rules('cant_meses','Cantidad de Meses','required|greater_than[0]');
			$this->form_validation->set_rules('tasa_interes','Tasa de Inter&eacute;s','required|greater_than[0]');


            if($this->form_validation->run())
            {
                   $params = array(
                   	'id'=> $id,
                    'monto_otorgamiento' => $this->input->post('monto_otorgamiento'),
                    'cant_meses' => $this->input->post('cant_meses'),
                    'tasa_interes'=> $this->input->post('tasa_interes'),
					'fecha_inicio' => $this->input->post('fecha_otorgamiento'),
					'meses_gracia' => $this->input->post('meses_gracia')
                   );

                  //$this->cuotas($id, $params);
                  $monto = $params['monto_otorgamiento'];
		          $cant_meses = $params['cant_meses'];
		          $meses_gracia = $params['meses_gracia'];
		          $tasa_diaria =  $params['tasa_interes']/365;

		          //$fecha_inicio_cuota = '2022-06-15'; //Fecha de la que queramos saber el nmero de das que tiene el mes.
		          //$fecha_inicio_cuota = $params['fecha_inicio'];
		          $fecha_inicio_cuota = '2022-05-15';
		          $cant_dias = date( 't', strtotime( $fecha_inicio_cuota ));
		          $fecha =  date("d-m-Y",strtotime($fecha_inicio_cuota."+ ".$cant_dias." days"));
		          $cant_dias_final = date( 't', strtotime( $fecha ));

		          // if ($meses_gracia  > 0){
		          //    $fecha_inicio_actual =  date("d-m-Y",strtotime($params['fecha_inicio'] ."+ ".$meses_gracia." month"));
		         // }else {
		          	 $fecha_inicio_actual = $params['fecha_inicio'];
		         // }

		          $cant_dias_actual = date( 't', strtotime( $fecha_inicio_actual ));
		          $fecha_actual =  date("d-m-Y",strtotime($fecha_inicio_actual ."+ ".$cant_dias_actual." days"));

		          $monto_mensual = $monto / $cant_meses;

		          $datos = array();
		          $monto_actual =  $monto;
		          for ($i=1;$i<=$cant_meses;$i++)
				    {
				       //$intereses_devengados= ($monto_actual*$tasa_diaria*$cant_dias)/100;
				       $intereses_devengados= ($monto_actual*$tasa_diaria*$cant_dias_final)/100;
				   	   $iva_interes= $intereses_devengados*0.21;


				   	   $datos[$i-1]= array('microbanco_credito_id'=>$id,
				   	   						'nro_cuota'=>$i,
				   	   						'fecha_vencimiento'=>$fecha_actual,
				   	   						'monto_cuota'=>$monto_mensual+ $intereses_devengados+$iva_interes);
                       $monto_actual = $monto_actual - $monto_mensual;


				       $cant_dias = date( 't', strtotime( $fecha ));
		          	   $fecha =  date("d-m-Y",strtotime($fecha."+ ".$cant_dias." days"));
		          	   $cant_dias_final = date( 't', strtotime( $fecha ));

		          	   //actual
		          	   $cant_dias_actual = date( 't', strtotime( $fecha_actual ));
		          	   $fecha_actual =  date("d-m-Y",strtotime($fecha_actual ."+ ".$cant_dias_actual." days"));
				    }
				  //  exit;

				$data['credito'] =  $params;
				$data['cuotas'] =  $datos;
               	$data['_view'] = 'calefones_credito/verificar_cuotas';
                $this->load->view('layouts/main',$data);
            }
            else
            {
                $data['_view'] = 'calefones_credito/plan_cuotas';
                $this->load->view('layouts/main',$data);
            }
        }
        else
            show_error('Datos NO encontrados.');
    }

     function editar_plan_cuotas($id)
    {
    	if (!$this->ion_auth->in_group('ingreso_datos'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['credito'] = $this->model->get_credito($id);
        $data['credito_cuotas'] =  $this->model->get_credito_cuotas_edit($id);

        if(isset($data['credito']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('fecha_otorgamiento','Fecha','required');
			$this->form_validation->set_rules('monto_otorgamiento','Monto','required|greater_than[0]');
			$this->form_validation->set_rules('cant_meses','Cantidad de Meses','required|greater_than[0]');
			$this->form_validation->set_rules('tasa_interes','Tasa de Inter&eacute;s','required|greater_than[0]');


            if($this->form_validation->run())
            {
                   $params = array(
                   	'id'=> $id,
                    'monto_otorgamiento' => $this->input->post('monto_otorgamiento'),
                    'cant_meses' => $this->input->post('cant_meses'),
                    'tasa_interes'=> $this->input->post('tasa_interes'),
					'fecha_inicio' => $this->input->post('fecha_otorgamiento'),
					'meses_gracia' => $this->input->post('meses_gracia')
                   );

                  $cuotas = $data['credito_cuotas'];

                  $monto = $params['monto_otorgamiento'];
		          $cant_meses = $params['cant_meses'];
		          $meses_gracia = $params['meses_gracia'];
		          $tasa_diaria =  $params['tasa_interes']/365;

		          //*****************************************

		         // $fecha_inicio_cuota = $params['fecha_inicio'];
		          $fecha_inicio_cuota = '2022-05-15';
		          $cant_dias = date( 't', strtotime( $fecha_inicio_cuota ));
		          $fecha =  date("d-m-Y",strtotime($fecha_inicio_cuota."+ ".$cant_dias." days"));
		          $cant_dias_final = date( 't', strtotime( $fecha ));

		          // if ($meses_gracia  > 0){
		          //    $fecha_inicio_actual =  date("d-m-Y",strtotime($params['fecha_inicio'] ."+ ".$meses_gracia." month"));
		          //}else {
		          	 $fecha_inicio_actual = $params['fecha_inicio'];
		          //}

		          $cant_dias_actual = date( 't', strtotime( $fecha_inicio_actual ));
		          $fecha_actual =  date("d-m-Y",strtotime($fecha_inicio_actual ."+ ".$cant_dias_actual." days"));

		          //********************************************

		          $monto_mensual = $monto / $cant_meses;

		          $datos = array();
		          $monto_actual =  $monto;
		           $i = 1;
		          foreach($cuotas as $clave => $valor)
				    {
		          	   //************************************************

		          	   $intereses_devengados= ($monto_actual*$tasa_diaria*$cant_dias_final)/100;
				   	   $iva_interes= $intereses_devengados*0.21;

                       $cuotas[$clave]['fecha_vencimiento']= $fecha_actual;
                       $cuotas[$clave]['monto_mensual'] = $monto_mensual;
				   	   $cuotas[$clave]['intereses_devengados'] =  $intereses_devengados;
				   	   $cuotas[$clave]['iva_interes'] = $iva_interes;
                       $cuotas[$clave]['monto_cuota']=$monto_mensual+ $intereses_devengados+$iva_interes;

                       $monto_actual = $monto_actual - $monto_mensual;


				       $cant_dias = date( 't', strtotime( $fecha ));
		          	   $fecha =  date("d-m-Y",strtotime($fecha."+ ".$cant_dias." days"));
		          	   $cant_dias_final = date( 't', strtotime( $fecha ));

		          	   //actual
		          	   $cant_dias_actual = date( 't', strtotime( $fecha_actual ));
		          	   $fecha_actual =  date("d-m-Y",strtotime($fecha_actual ."+ ".$cant_dias_actual." days"));


		          	   //***********************************************
				    }

				$data['credito'] =  $params;
				$data['cuotas'] =  $cuotas;
                $data['_view'] = 'calefones_credito/editar_verificar_cuotas';
                $this->load->view('layouts/main',$data);
            }
            else
            {
                $data['_view'] = 'calefones_credito/editar_plan_cuotas';
                $this->load->view('layouts/main',$data);
            }
        }
        else
            show_error('Datos NO encontrados.');
    }


     /*
     * Editing a estado
     */
    function verificar_cuotas($id)
    {
      if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
     // check if the estado exists before trying to edit it
        $data['credito'] = $this->model->get_credito($id);

        if(isset($data['credito']['id']))
        {
            if(isset($_POST) && count($_POST) > 0)
             {
                 $cant_meses = $this->input->post('cant_meses');
                 $meses_gracia = $this->input->post('meses_gracia');
                 $tasa_interes = $this->input->post('tasa_interes');
                 $monto = $this->input->post('monto_otorgamiento');



                   $cuotas = array();
                   $total=0;

                   for ($i = 0; $i < $cant_meses; $i++) {
					    $cuotas[$i]= array('calefones_credito_id'=> $id,
					    					'nro_cuota'=>$this->input->post('nro_cuota['.$i.']'),
					    					'fecha_vencimiento'=> date("Y-m-d", strtotime( $this->input->post('fecha_vencimiento['.$i.']') )),
					    					'monto_cuota'=>$this->input->post('monto_cuota['.$i.']'),
					    					'tasa_interes'=> $tasa_interes
					    					);
					    $total +=$this->input->post('monto_cuota['.$i.']');
					}

					$update_credito = array(
                    'monto_otorgamiento' => $monto,
                    'cant_meses' => $cant_meses,
                    'meses_gracia' => $meses_gracia,
                    'tasa_interes'=> $tasa_interes,
                    'total_credito'=> $total,
                    'gerenar_cuota'=> 1,
                   );

				   $this->model->update_credito($id,$update_credito);
				   $this->model->insert_cuotas($cuotas);
                   redirect('Calefones_credito/detalle/'. $id);
             }

        }
        else
            show_error('Datos NO encontrados.');
    }


    function editar_verificar_cuotas($id)
    {
      if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
     // check if the estado exists before trying to edit it
        $data['credito'] = $this->model->get_credito($id);

        if(isset($data['credito']['id']))
        {
            if(isset($_POST) && count($_POST) > 0)
             {
                 $cant_meses = $this->input->post('cant_meses');
                 $meses_gracia = $this->input->post('meses_gracia');
                 $tasa_interes = $this->input->post('tasa_interes');
                 $monto = $this->input->post('monto_otorgamiento');

                   $cuotas = array();
                   $total=0;

                   for ($i = 0; $i < ($cant_meses+$meses_gracia); $i++) {
                         $cuotas[$i]= array('id'=> $this->input->post('id['.$i.']'),
					    					'fecha_vencimiento'=> date("Y-m-d", strtotime( $this->input->post('fecha_vencimiento['.$i.']') )),
					    					'monto_cuota'=>$this->input->post('monto_cuota['.$i.']'),
					    					);
					    $total +=$this->input->post('monto_cuota['.$i.']');
					}

					$update_credito = array(
					'meses_gracia' => $meses_gracia,
                    'total_credito'=> $total
                   );


				   $this->model->update_credito($id,$update_credito);
				   $this->model->update_all_cuotas($cuotas);
                   redirect('Calefones_credito/detalle/'. $id);
             }

        }
        else
            show_error('Datos NO encontrados.');
    }

      /*
     * Editing a estado
     */
    function cuota_edit($id)
    {
     if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
        // check if the estado exists before trying to edit it
        $data['cuota'] = $this->model->get_cuota($id);

        if(isset($data['cuota']['id']))
        {
           $this->load->library('form_validation');
		   $this->form_validation->set_rules('monto_depositado','Monto Depositado','required|greater_than[0]');


            if($this->form_validation->run())
            {
                $params = array(
					//'fecha_vencimiento' => $this->input->post('fecha_vencimiento'),
					//'monto_cuota' => $this->input->post('monto_cuota'),
					'fecha_pago' => $this->input->post('fecha_pago'),
					'monto_depositado' => $this->input->post('monto_depositado'),
					'estado' => 1,
					'observaciones' => $this->input->post('observaciones'),
                );

                $this->model->update_cuota($id,$params);
                redirect('Calefones_credito/detalle/'.$data['cuota']['calefones_credito_id']);
            }
            else
            {
                $data['_view'] = 'calefones_credito/cuota_edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
           show_error('Datos NO encontrados.');
    }


    /*
     * Deleting estado
     */
    function remove($id)
    {
      if (!$this->ion_auth->in_group('admin'))
      {
       redirect('/', 'refresh');
      }
      $credito = $this->model->get_credito($id);

        // check if the estado exists before trying to delete it
        if(isset($credito['id']))
        {
            $this->model->delete_credito($id);
            redirect('Calefones_credito/index');
        }
        else
            show_error('Datos NO encontrados.');
    }

       function finalizar($id)
    {
      if (!$this->ion_auth->in_group('ingreso_datos'))
      {
       redirect('/', 'refresh');
      }
      $credito = $this->model->get_credito($id);

        // check if the estado exists before trying to delete it
        if(isset($credito['id']))
        {
            $params = array('finalizado'=>1,'finalizadoFecha'=>date('Y-m-d H:i:s'));
            $credito = $this->model->update_credito($id, $params);
            redirect('Calefones_credito/detalle/'.$id);
        }
        else
            show_error('Datos NO encontrados.');
    }

}
