<?php

class Calefones_inscripcion extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }else if (!$this->ion_auth->is_admin())
		{
			redirect('/', 'refresh');
		}
        $this->load->model('Calefones_inscripcion_model');
    }

    /*
     * Listing of calefones_inscripciones
     */
    function index()
    {
        $data['calefones_inscripciones'] = $this->Calefones_inscripcion_model->get_all_calefones_inscripciones();

        $data['_view'] = 'calefones_inscripcion/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new calefones_inscripcion
     */
    function add()
    {
        if(isset($_POST) && count($_POST) > 0)
        {
            $params = array(
				'localidad_id' => $this->input->post('localidad_id'),
				'persona_id' => $this->input->post('persona_id'),
				'estado_id' => $this->input->post('estado_id'),
				'fecha' => $this->input->post('fecha'),
				'email' => $this->input->post('email'),
				'ape_nom' => $this->input->post('ape_nom'),
				'dni' => $this->input->post('dni'),
				'estado_civil' => $this->input->post('estado_civil'),
				'fecha_titular_vivienda' => $this->input->post('fecha_titular_vivienda'),
				'grupo_familiar' => $this->input->post('grupo_familiar'),
				'telefono' => $this->input->post('telefono'),
				'domicilio' => $this->input->post('domicilio'),
				'localidad' => $this->input->post('localidad'),
				'registro_propiedad' => $this->input->post('registro_propiedad'),
				'zona_vivienda' => $this->input->post('zona_vivienda'),
				'servicios_publicos_zona' => $this->input->post('servicios_publicos_zona'),
				'material_vivienda' => $this->input->post('material_vivienda'),
				'fuente_ingresos' => $this->input->post('fuente_ingresos'),
				'ingresos_familiar' => $this->input->post('ingresos_familiar'),
				'nom_ape_garante' => $this->input->post('nom_ape_garante'),
				'dni_garante' => $this->input->post('dni_garante'),
				'estado_civil_garante' => $this->input->post('estado_civil_garante'),
				'domicilio_garante' => $this->input->post('domicilio_garante'),
				'localidad_garante' => $this->input->post('localidad_garante'),
				'lugar_trabajo_garante' => $this->input->post('lugar_trabajo_garante'),
				'ingresos_garante' => $this->input->post('ingresos_garante'),
				'fecha_armar_carpeta' => $this->input->post('fecha_armar_carpeta'),
				'tecnico_asignado_factivilidad' => $this->input->post('tecnico_asignado_factivilidad'),
				'fecha_visita_factibilidad' => $this->input->post('fecha_visita_factibilidad'),
				'fecha_presentacion_informe' => $this->input->post('fecha_presentacion_informe'),
				'evaluador_asignado' => $this->input->post('evaluador_asignado'),
				'estado' => $this->input->post('estado'),
				'AC' => $this->input->post('AC'),
				'AD' => $this->input->post('AD'),
				'AE' => $this->input->post('AE'),
				'AF' => $this->input->post('AF'),
				'AG' => $this->input->post('AG'),
				'AH' => $this->input->post('AH'),
				'AI' => $this->input->post('AI'),
				'AJ' => $this->input->post('AJ'),
            );

            $calefones_inscripcion_id = $this->Calefones_inscripcion_model->add_calefones_inscripcion($params);
            redirect('calefones_inscripcion/index');
        }
        else
        {
			$this->load->model('Localidad_model');
			$data['all_localidades'] = $this->Localidad_model->get_all_localidades();

			$this->load->model('Persona_model');
			$data['all_personas'] = $this->Persona_model->get_all_personas();

			$this->load->model('Estado_model');
			$data['all_estados'] = $this->Estado_model->get_all_estados();

            $data['_view'] = 'calefones_inscripcion/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a calefones_inscripcion
     */
    function edit($id)
    {
        // check if the calefones_inscripcion exists before trying to edit it
        $data['calefones_inscripcion'] = $this->Calefones_inscripcion_model->get_calefones_inscripcion($id);

        if(isset($data['calefones_inscripcion']['id']))
        {
            if(isset($_POST) && count($_POST) > 0)
            {
                $params = array(
					'localidad_id' => $this->input->post('localidad_id'),
					'persona_id' => $this->input->post('persona_id'),
					'estado_id' => $this->input->post('estado_id'),
					'fecha' => $this->input->post('fecha'),
					'email' => $this->input->post('email'),
					'ape_nom' => $this->input->post('ape_nom'),
					'dni' => $this->input->post('dni'),
					'estado_civil' => $this->input->post('estado_civil'),
					'fecha_titular_vivienda' => $this->input->post('fecha_titular_vivienda'),
					'grupo_familiar' => $this->input->post('grupo_familiar'),
					'telefono' => $this->input->post('telefono'),
					'domicilio' => $this->input->post('domicilio'),
					'localidad' => $this->input->post('localidad'),
					'registro_propiedad' => $this->input->post('registro_propiedad'),
					'zona_vivienda' => $this->input->post('zona_vivienda'),
					'servicios_publicos_zona' => $this->input->post('servicios_publicos_zona'),
					'material_vivienda' => $this->input->post('material_vivienda'),
					'fuente_ingresos' => $this->input->post('fuente_ingresos'),
					'ingresos_familiar' => $this->input->post('ingresos_familiar'),
					'nom_ape_garante' => $this->input->post('nom_ape_garante'),
					'dni_garante' => $this->input->post('dni_garante'),
					'estado_civil_garante' => $this->input->post('estado_civil_garante'),
					'domicilio_garante' => $this->input->post('domicilio_garante'),
					'localidad_garante' => $this->input->post('localidad_garante'),
					'lugar_trabajo_garante' => $this->input->post('lugar_trabajo_garante'),
					'ingresos_garante' => $this->input->post('ingresos_garante'),
					'fecha_armar_carpeta' => $this->input->post('fecha_armar_carpeta'),
					'tecnico_asignado_factivilidad' => $this->input->post('tecnico_asignado_factivilidad'),
					'fecha_visita_factibilidad' => $this->input->post('fecha_visita_factibilidad'),
					'fecha_presentacion_informe' => $this->input->post('fecha_presentacion_informe'),
					'evaluador_asignado' => $this->input->post('evaluador_asignado'),
					'estado' => $this->input->post('estado'),
					'AC' => $this->input->post('AC'),
					'AD' => $this->input->post('AD'),
					'AE' => $this->input->post('AE'),
					'AF' => $this->input->post('AF'),
					'AG' => $this->input->post('AG'),
					'AH' => $this->input->post('AH'),
					'AI' => $this->input->post('AI'),
					'AJ' => $this->input->post('AJ'),
                );

                $this->Calefones_inscripcion_model->update_calefones_inscripcion($id,$params);
                redirect('calefones_inscripcion/index');
            }
            else
            {
				$this->load->model('Localidad_model');
				$data['all_localidades'] = $this->Localidad_model->get_all_localidades();

				$this->load->model('Persona_model');
				$data['all_personas'] = $this->Persona_model->get_all_personas();

				$this->load->model('Estado_model');
				$data['all_estados'] = $this->Estado_model->get_all_estados();

                $data['_view'] = 'calefones_inscripcion/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
            show_error('The calefones_inscripcion you are trying to edit does not exist.');
    }

    /*
     * Deleting calefones_inscripcion
     */
    function remove($id)
    {
        $calefones_inscripcion = $this->Calefones_inscripcion_model->get_calefones_inscripcion($id);

        // check if the calefones_inscripcion exists before trying to delete it
        if(isset($calefones_inscripcion['id']))
        {
            $this->Calefones_inscripcion_model->delete_calefones_inscripcion($id);
            redirect('calefones_inscripcion/index');
        }
        else
            show_error('The calefones_inscripcion you are trying to delete does not exist.');
    }

}
