<?php

class Convocatoria extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('Convocatoria_model', 'model');
    }

    /*
     * Listing of estados
     */
    function index()
    {
       if (!$this->ion_auth->in_group('ingreso_microbanco'))
      	{
       	redirect('/', 'refresh');
      	}
        $data['convocatorias'] = $this->model->get_all_convocatorias();

        $data['_view'] = 'convocatoria/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new estado
     */
    function add()
    {
        if (!$this->ion_auth->in_group('ingreso_microbanco'))
      	{
       	redirect('/', 'refresh');
      	}

        if(isset($_POST) && count($_POST) > 0)
        {
            $params = array(
				'activo' => 1,
				'convocatoria' => $this->input->post('convocatoria'),
				'color' => 'bg-blue',
				'icono' => 'fa-address-book',
				'orden' => 7,
				'color_hex' => '#007bff',
            );

            $convocatoria_id = $this->model->add_convocatoria($params);
            redirect('convocatoria/index');
        }
        else
        {
            $data['_view'] = 'convocatoria/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a estado
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('ingreso_microbanco'))
      	{
       	redirect('/', 'refresh');
      	}
        // check if the estado exists before trying to edit it
        $data['convocatoria'] = $this->model->get_convocatoria($id);

        if(isset($data['convocatoria']['id']))
        {
            if(isset($_POST) && count($_POST) > 0)
            {
                $params = array(
					'convocatoria' => $this->input->post('convocatoria'),
                );

                $this->model->update_convocatoria($id,$params);
                redirect('convocatoria/index');
            }
            else
            {
                $data['_view'] = 'convocatoria/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
            show_error('The estado you are trying to edit does not exist.');
    }

    /*
     * Deleting estado
     */
    function remove($id)
    {
        if (!$this->ion_auth->is_admin())
		{
			redirect('/', 'refresh');
		}

        $convocatoria = $this->model->get_convocatoria($id);

        // check if the estado exists before trying to delete it
        if(isset($convocatoria['id']))
        {
            $this->model->delete_convocatoria($id);
            redirect('convocatoria/index');
        }
        else
            show_error('The estado you are trying to delete does not exist.');
    }

}
