<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class EntregasCompras extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

	    /*else if (!$this->ion_auth->is_admin())
		{
			redirect('/', 'refresh');
		}  */

        $this->load->model('EntregasCompras_model', 'model');
    }


      /*
     * Listar Inscripciones por Usuario -
     */
    function index()
    {
     if (!$this->ion_auth->in_group('compras_orden'))
      {
       redirect('/', 'refresh');
      }

        $data['ordenes'] = $this->model->get_all_entregadeproducto();

        $data['_view'] = 'entrega_compra/index';
      	$this->load->view('layouts/main',$data);
    }


    function detalle($id)
    {

        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $data['ordencompra'] = $this->model->get_entregadeproducto($id);

        $data['_view'] = 'entrega_compra/detalle';

        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new notas_calefon
     */
    function add()
    {
        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $this->load->library('form_validation');

		$this->form_validation->set_rules('empleado_id','Retir&oacute;','required|integer');
		 $this->form_validation->set_rules('listaProductos', 'Productos', 'required',
                        array('required' => 'Debes agregar %s a la Entrega.')
                );

		if($this->form_validation->run())
        {

           //$listaProductos = json_decode($_POST["listaProductos"], true);

            $params = array(
            	'empleado_id' => $this->input->post('empleado_id'),
				'observaciones' => $this->input->post('observaciones'),
				'productos' => $_POST["listaProductos"],
				'user_id' => $this->session->userdata('user_id'),
				'created'=> date('Y-m-d H:i:s'),
            );

            $ordendecompra_id = $this->model->insert_entrega_producto($params);
            redirect('EntregasCompras/index');
        }
        else
        {
			$data['all_empleados'] = $this->model->get_all_empleados();

            $data['_view'] = 'entrega_compra/add';
            $this->load->view('layouts/main',$data);
        }
    }

     function add_producto()
    {
    	 if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $producto = $this->input->post('nuevoProducto');
        $permite_stock = $this->input->post('permite_stock');

        if (!empty($producto))
        {
            $params = array(
            	'descripcion' => $this->input->post('nuevoProducto'),
				'permite_stock' => $this->input->post('permite_stock'),
				'stock' => 0,
				'precio_venta' =>  0,
				'fecha'=> date('Y-m-d H:i:s'),
            );

             $producto_id = $this->model->add_producto($params);

             if ($producto_id > 0)
             {
              	echo json_encode($producto_id);
             }else {
               echo json_encode(-1);
             }
              return;


        }

       echo json_encode(-1);
       return;
    }

    function get_all_productos()
    {
      //$data = $this->model->get_all_productos();
     // echo json_encode($data);

      $item = null;
    	$valor = null;
    	$orden = "id";

  		$productos = $this->model->get_all_productos();

  		if(count($productos) == 0){

  			echo '{"data": []}';

		  	return;
  		}

  		$datosJson = '{
		  "data": [';

		  for($i = 0; $i < count($productos); $i++){

		  	/*=============================================
 	 		TRAEMOS LA IMAGEN
  			=============================================*/

		  	$imagen = "<img src='".base_url('assets/dist/img/anonymous.png')."' width='40px'>";

		  	/*=============================================
 	 		STOCK
  			=============================================*/
           	if($productos[$i]["permite_stock"]){
	  			if($productos[$i]["stock"] <= 10){

	  				$stock = "<button class='btn btn-danger'>".$productos[$i]["stock"]."</button>";

	  			}else if($productos[$i]["stock"] > 11 && $productos[$i]["stock"] <= 15){

	  				$stock = "<button class='btn btn-warning'>".$productos[$i]["stock"]."</button>";

	  			}else{

	  				$stock = "<button class='btn btn-success'>".$productos[$i]["stock"]."</button>";

	  			}
	  		}else {
	  			$stock = '';
	  		}

		  	/*=============================================
 	 		TRAEMOS LAS ACCIONES
  			=============================================*/

		  	$botones =  "<div class='btn-group'><button class='btn btn-primary agregarProducto recuperarBoton' idProducto='".$productos[$i]["id"]."'>Agregar</button></div>";

		  	$datosJson .='[
			      "'.($i+1).'",
			      "'.$imagen.'",
			      "'.$productos[$i]["descripcion"].'",
			      "'.$stock.'",
			      "'.$botones.'"
			    ],';

		  }

		  $datosJson = substr($datosJson, 0, -1);

		 $datosJson .=   ']

		 }';

		echo $datosJson;
    }

     function get_producto()
    {
      $item = "id";
      $valor =  $this->input->post('idProducto');
      $orden = "id";


      $respuesta = $this->model->get_producto($valor);

      echo json_encode($respuesta);
    }

    function itemedit($id)
    {
    	 if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $data['item'] = $this->model->get_ordendecompraitem($id);

      	if(isset($data['item']['id']))
        {
           if($data['item']['estado_id'] == 1)
       		 {
		       $this->load->library('form_validation');

				$this->form_validation->set_rules('cantidad','Cantidad','required');
				$this->form_validation->set_rules('importe','Importe','required');


				if($this->form_validation->run())
		        {

		            $params = array(
		            	'cantidad' => $this->input->post('cantidad'),
		            	'importe' => $this->input->post('importe'),
						'updated'=> date('Y-m-d H:i:s'),
		            );

		            $item_id = $this->model->update_ordendecompraitem($id, $params);
		            redirect('EntregasCompras/index');
		        }
		        else
		        {
		            $data['_view'] = 'ordencompra/edititem';
		            $this->load->view('layouts/main',$data);
		        }
	        }else {
	     		$this->session->set_flashdata('error', 'No se pudo Actualizar el Item.');
            	redirect('EntregasCompras/index');
	    	}



        }else {
        	$this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('EntregasCompras/index');
         }
    }


     function itemremove($id)
    {
        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $ordencompra = $this->model->get_ordendecompraitem($id);

        // check if the notas_calefon exists before trying to delete it
        if(isset($ordencompra['id']))
        {
            if($ordencompra['estado_id'] == 4)
        	{
        	 	$this->session->set_flashdata('error', 'No se puede actualizar una Orden Anulada.');
            	redirect('EntregasCompras/detalle/'. $ordencompra['ordendecompra_id']);

        	}else {
            	$params = array('isDelete'=>1,'deleteFecha'=>date('Y-m-d H:i:s'));
             	$ordencompra_res = $this->model->update_ordendecompraitem($id, $params);
             	$this->session->set_flashdata('success', 'La Datos se han actualizado Correctamente.');

            	redirect('EntregasCompras/detalle/'. $ordencompra['ordendecompra_id']);
            }
        }
         else
        {

            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('EntregasCompras/index');
        }
    }

    function anular($id)
    {
        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}
        $ordencompra = $this->model->get_ordendecompra($id);
        // check if the notas_calefon exists before trying to delete it
        if(isset($ordencompra['id']))
        {

           if($ordencompra['estado_id'] == 4)
        	{
        	 	$this->session->set_flashdata('error', 'No se puede actualizar una Orden Anulada.');
            	redirect('EntregasCompras/index');

        	}else {
            	$params = array('estado_id' => 4, 'isAnular'=>1,'anularFecha'=>date('Y-m-d H:i:s'));
            	$ordencompra = $this->model->update_ordendecompra($id, $params);
            	$this->session->set_flashdata('success', 'La Datos se han actualizado Correctamente.');
           	 	redirect('EntregasCompras/index');
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Anular no existe o no tienes los permisos para su acceso.');
            redirect('EntregasCompras/index');
        }
    }

       function estado($id)
    {

        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

      	$data['ordendecompra'] = $this->model->get_ordendecompra($id);

      	 if(isset($data['ordendecompra']['id']))
        {

           if(($data['ordendecompra']['estado_id'] != 3) and ($data['ordendecompra']['estado_id']!=4))
       		 {
		       $this->load->library('form_validation');

				$this->form_validation->set_rules('estado_id','Estado','required|integer');


				if($this->form_validation->run())
		        {
                    $estado = $this->input->post('estado_id');
		            $params = array(
		            	'estado_id' => $estado,
						'updateestado'=> date('Y-m-d H:i:s'),
		            );

		             $estadohistorial = array(
		             	'ordendecompra_id'=> $id,
		            	'estado_id' => $estado,
		            	'observaciones' => $this->input->post('detalle'),
		            	'user_id' => $this->session->userdata('user_id'),
						'created'=> date('Y-m-d H:i:s'),
		            );

		            $items = array();
		             //si estado_id = 3 "Entregado" - actualizar stock de productos.
		            if ($estado == 3){
		            	//obtenemos los items de la orden de compra.
                        $items = $this->model->get_ordendecompraitem_actualizarstock($id);
		            }

		            $ordendecompra_id = $this->model->add_historial_estado($id, $params, $estadohistorial, $items);

		            //si estado_id = 3 "Entregado" - actualizar stock de productos.

		            redirect('EntregasCompras/index');
		        }
		        else
		        {
					$data['all_estados'] = $this->model->get_all_ordenestados();

		            $data['_view'] = 'entrega_compra/ordenestados';
		            $this->load->view('layouts/main',$data);
		        }
	        }else {
	     		$this->session->set_flashdata('error', 'No se pudo cambiar el Estado, porque la Orden est&aacute; Entregada o Anulada.');
            	redirect('EntregasCompras/index');
	    	}
	    }else {
	     	$this->session->set_flashdata('error', 'No se pudo cambiar el Estado a la Orden porque no existe o no tienes los permisos para su acceso.');
            redirect('EntregasCompras/index');
	    }

    }


      function imprimirOrden($id)
    {

        if (!$this->ion_auth->in_group('compras_orden'))
      	{
       		redirect('/', 'refresh');
      	}

        $ordencompra = $this->model->get_ordendecompra($id);
        $itemscompras = $this->model->get_all_itemsordendecompra($id);

		// Include the main TCPDF library (search for installation path).
		$this->load->library('CAFESGPDF');

		// create new PDF document
		$pdf = new CAFESGPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

		// set document information
		$pdf->SetCreator(PDF_CREATOR);
		$pdf->SetAuthor('Nicola Asuni');
		$pdf->SetTitle('CAFESG');
		$pdf->SetSubject('Orden de Compra');
		$pdf->SetKeywords('CAFESG, PDF, compra');

		// set default header data
		$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 001', PDF_HEADER_STRING, array(0,64,255), array(0,64,128));
		$pdf->setFooterData(array(0,64,0), array(0,64,128));

		// set header and footer fonts
		$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
		$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

		// set default monospaced font
		$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

		// set margins
		$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
		$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
		$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

		// set auto page breaks
		$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

		// set image scale factor
		$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

		// set some language-dependent strings (optional)
		//if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
		//   require_once(dirname(__FILE__).'/lang/eng.php');
		 //   $pdf->setLanguageArray($l);
		//}

		// ---------------------------------------------------------

		// set default font subsetting mode
		$pdf->setFontSubsetting(true);

		// Set font
		// dejavusans is a UTF-8 Unicode font, if you only need to
		// print standard ASCII chars, you can use core fonts like
		// helvetica or times to reduce file size.
		$pdf->SetFont('dejavusans', '', 12, '', true);

		// Add a page
		// This method has several options, check the source code documentation for more information.
		$pdf->AddPage();

		// set text shadow effect
		$pdf->setTextShadow(array('enabled'=>true, 'depth_w'=>0.2, 'depth_h'=>0.2, 'color'=>array(196,196,196), 'opacity'=>1, 'blend_mode'=>'Normal'));

		// Set some content to print
		$texto = '<p align="right"><b>Orden N&uacute;mero: '. str_pad($ordencompra['id'], 10, "0", STR_PAD_LEFT) .'</b></p>';
		//echo strftime("%A %d de %B del %Y");

		setlocale(LC_TIME, "spanish");

		//$texto .= '<p align="right">Concordia, '.strftime("%A %d de %B del %Y", date("d/m/Y", strtotime($ordencompra['fechaingreso']))) .'</p>';
		$texto .= '<p align="right"><b>Concordia, '. date("d/m/Y", strtotime($ordencompra['fechaingreso'])).'</b></p>';
		$texto .= '<p align="center"><u>ORDEN DE COMPRA - CONTRATACI&Oacute;N DIRECTA</u></p>';
		$texto .= '<p><b>Sres Directotio</b><br/>';
		$texto .= '<b>C.A.F.E.S.G.</b><br/>';
		$texto .= '<b><u>S&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;D</u></b></p>';
       	$texto .= '<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
       				Solicito de autorizaci&oacute;n para la adquisici&oacute;n de los siguientes art&iacute;culos y/o la contrataci&oacute;n de los siguientes servicios, bajo la modalidad compra directa sin cotejo, de acuerdo a lo dispuesto en Decreto Nro 95 M.E.H.F. y sus modificatorias.</p>';
       	$texto .='<table border="1" width="100%"><tr><td align="center"><b>Cantidad</b></td><td align="center"><b>Detalle</b></td><td align="center"><b>Importe</b></td></tr>';
  		$total = 0;
    	foreach($itemscompras as $n){
       	   $total += $n['importe'];
       	  $texto .='<tr><td align="center">'.$n['cantidad'].'</td><td>&nbsp;'.$n['producto_nombre'].' '.$n['producto_observacion'].'</td><td align="center">&nbsp;'.number_format($n['importe'],2 ,",", ".").'</td></tr>';
       	}
       	$texto .='<tr><td></td><td align="center">TOTAL</td><td align="center">&nbsp;<b>'. number_format($total,2 ,",", ".").'</b></td></tr>';
       	$texto .='</table>';
        $texto .='<br /><br />Observaciones:&nbsp;&nbsp;'.$ordencompra['observaciones'];
        $texto .='<br />Destino Oficinas:&nbsp;&nbsp;'.$ordencompra['area'];

       	$texto .='<p><u>PRESUPUESTO PREVISTO PARA LA COMPRA</u></p>';
       	$texto .='<p>Son Pesos:<b>'.  $this->convertir($total) . '</b><p>';
       	$texto .='<table border="1" width="100%"><tr><td><b><u>IMPORTANTE:</u></b> Esta Comisi&oacute;n no reconocer&aacute; nunguna factura cuyo importe supere el presupuesto previsto en la planilla de autorizaci&oacute;n y no se encuentre debidamente firmada por el responsable que autorizo y/o efectu&oacute; la compra. La misma deber&aacute; acompa&ntilde;ar a respectiva factura.</td></tr></table>';
       	$texto .='<br/><br/><br/><br/><br/><br/>';
       	$texto .='<table width="100%"><tr>';
       	$texto .='<td align="center"><u><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b></u><br/>Firma Solicitante<br/>Encargado de Compras</td>';
       	$texto .='<td align="center"><u><b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b></u><br />Firma Aprobaci&oacute;n<br/>Directorio</td>';
        $texto .='</tr></table>';
		// Print text using writeHTMLCell()
		$pdf->writeHTMLCell(0, 0, '', '', $texto, 0, 1, 0, true, '', true);

		// ---------------------------------------------------------

		// Close and output PDF document
		// This method has several options, check the source code documentation for more information.
		$pdf->Output('orden_de_compra.pdf', 'I');

		//============================================================+
		// END OF FILE
		//============================================================+
    }


    private function unidad($numuero){
		switch ($numuero)
		{
			case 9:
			{
				$numu = "NUEVE";
				break;
			}
			case 8:
			{
				$numu = "OCHO";
				break;
			}
			case 7:
			{
				$numu = "SIETE";
				break;
			}
			case 6:
			{
				$numu = "SEIS";
				break;
			}
			case 5:
			{
				$numu = "CINCO";
				break;
			}
			case 4:
			{
				$numu = "CUATRO";
				break;
			}
			case 3:
			{
				$numu = "TRES";
				break;
			}
			case 2:
			{
				$numu = "DOS";
				break;
			}
			case 1:
			{
				$numu = "UNO";
				break;
			}
			case 0:
			{
				$numu = "";
				break;
			}
		}
		return $numu;
	}

	private function decena($numdero){

		if ($numdero >= 90 && $numdero <= 99)
		{
			$numd = "NOVENTA ";
			if ($numdero > 90)
				$numd = $numd."Y ".($this->unidad($numdero - 90));
		}
		else if ($numdero >= 80 && $numdero <= 89)
		{
			$numd = "OCHENTA ";
			if ($numdero > 80)
				$numd = $numd."Y ".($this->unidad($numdero - 80));
		}
		else if ($numdero >= 70 && $numdero <= 79)
		{
			$numd = "SETENTA ";
			if ($numdero > 70)
				$numd = $numd."Y ".($this->unidad($numdero - 70));
		}
		else if ($numdero >= 60 && $numdero <= 69)
		{
			$numd = "SESENTA ";
			if ($numdero > 60)
				$numd = $numd."Y ".($this->unidad($numdero - 60));
		}
		else if ($numdero >= 50 && $numdero <= 59)
		{
			$numd = "CINCUENTA ";
			if ($numdero > 50)
				$numd = $numd."Y ".($this->unidad($numdero - 50));
		}
		else if ($numdero >= 40 && $numdero <= 49)
		{
			$numd = "CUARENTA ";
			if ($numdero > 40)
				$numd = $numd."Y ".($this->unidad($numdero - 40));
		}
		else if ($numdero >= 30 && $numdero <= 39)
		{
			$numd = "TREINTA ";
			if ($numdero > 30)
				$numd = $numd."Y ".($this->unidad($numdero - 30));
		}
		else if ($numdero >= 20 && $numdero <= 29)
		{
			if ($numdero == 20)
				$numd = "VEINTE ";
			else
				$numd = "VEINTI".($this->unidad($numdero - 20));
		}
		else if ($numdero >= 10 && $numdero <= 19)
		{
			switch ($numdero){
			case 10:
			{
				$numd = "DIEZ ";
				break;
			}
			case 11:
			{
				$numd = "ONCE ";
				break;
			}
			case 12:
			{
				$numd = "DOCE ";
				break;
			}
			case 13:
			{
				$numd = "TRECE ";
				break;
			}
			case 14:
			{
				$numd = "CATORCE ";
				break;
			}
			case 15:
			{
				$numd = "QUINCE ";
				break;
			}
			case 16:
			{
				$numd = "DIECISEIS ";
				break;
			}
			case 17:
			{
				$numd = "DIECISIETE ";
				break;
			}
			case 18:
			{
				$numd = "DIECIOCHO ";
				break;
			}
			case 19:
			{
				$numd = "DIECINUEVE ";
				break;
			}
			}
		}
		else
			$numd = $this->unidad($numdero);
		return $numd;
	}

	private function centena($numc){
		if ($numc >= 100)
		{
			if ($numc >= 900 && $numc <= 999)
			{
				$numce = "NOVECIENTOS ";
				if ($numc > 900)
					$numce = $numce.($this->decena($numc - 900));
			}
			else if ($numc >= 800 && $numc <= 899)
			{
				$numce = "OCHOCIENTOS ";
				if ($numc > 800)
					$numce = $numce.($this->decena($numc - 800));
			}
			else if ($numc >= 700 && $numc <= 799)
			{
				$numce = "SETECIENTOS ";
				if ($numc > 700)
					$numce = $numce.($this->decena($numc - 700));
			}
			else if ($numc >= 600 && $numc <= 699)
			{
				$numce = "SEISCIENTOS ";
				if ($numc > 600)
					$numce = $numce.($this->decena($numc - 600));
			}
			else if ($numc >= 500 && $numc <= 599)
			{
				$numce = "QUINIENTOS ";
				if ($numc > 500)
					$numce = $numce.($this->decena($numc - 500));
			}
			else if ($numc >= 400 && $numc <= 499)
			{
				$numce = "CUATROCIENTOS ";
				if ($numc > 400)
					$numce = $numce.($this->decena($numc - 400));
			}
			else if ($numc >= 300 && $numc <= 399)
			{
				$numce = "TRESCIENTOS ";
				if ($numc > 300)
					$numce = $numce.($this->decena($numc - 300));
			}
			else if ($numc >= 200 && $numc <= 299)
			{
				$numce = "DOSCIENTOS ";
				if ($numc > 200)
					$numce = $numce.($this->decena($numc - 200));
			}
			else if ($numc >= 100 && $numc <= 199)
			{
				if ($numc == 100)
					$numce = "CIEN ";
				else
					$numce = "CIENTO ".($this->decena($numc - 100));
			}
		}
		else
			$numce = $this->decena($numc);

		return $numce;
	}

	private function miles($nummero){
		if ($nummero >= 1000 && $nummero < 2000){
			$numm = "MIL ".($this->centena($nummero%1000));
		}
		if ($nummero >= 2000 && $nummero <10000){
			$numm = $this->unidad(Floor($nummero/1000))." MIL ".($this->centena($nummero%1000));
		}
		if ($nummero < 1000)
			$numm = $this->centena($nummero);

		return $numm;
	}

	private function decmiles($numdmero){
		if ($numdmero == 10000)
			$numde = "DIEZ MIL";
		if ($numdmero > 10000 && $numdmero <20000){
			$numde = $this->decena(Floor($numdmero/1000))."MIL ".($this->centena($numdmero%1000));
		}
		if ($numdmero >= 20000 && $numdmero <100000){
			$numde = $this->decena(Floor($numdmero/1000))." MIL ".($this->miles($numdmero%1000));
		}
		if ($numdmero < 10000)
			$numde = $this->miles($numdmero);

		return $numde;
	}

	private function cienmiles($numcmero){
		if ($numcmero == 100000)
			$num_letracm = "CIEN MIL";
		if ($numcmero >= 100000 && $numcmero <1000000){
			$num_letracm = $this->centena(Floor($numcmero/1000))." MIL ".($this->centena($numcmero%1000));
		}
		if ($numcmero < 100000)
			$num_letracm = $this->decmiles($numcmero);
		return $num_letracm;
	}

	private function millon($nummiero){
		if ($nummiero >= 1000000 && $nummiero <2000000){
			$num_letramm = "UN MILLON ".($this->cienmiles($nummiero%1000000));
		}
		if ($nummiero >= 2000000 && $nummiero <10000000){
			$num_letramm = $this->unidad(Floor($nummiero/1000000))." MILLONES ".($this->cienmiles($nummiero%1000000));
		}
		if ($nummiero < 1000000)
			$num_letramm = $this->cienmiles($nummiero);

		return $num_letramm;
	}

	private function decmillon($numerodm){
		if ($numerodm == 10000000)
			$num_letradmm = "DIEZ MILLONES";
		if ($numerodm > 10000000 && $numerodm <20000000){
			$num_letradmm = $this->decena(Floor($numerodm/1000000))."MILLONES ".($this->cienmiles($numerodm%1000000));
		}
		if ($numerodm >= 20000000 && $numerodm <100000000){
			$num_letradmm = $this->decena(Floor($numerodm/1000000))." MILLONES ".($this->millon($numerodm%1000000));
		}
		if ($numerodm < 10000000)
			$num_letradmm = $this->millon($numerodm);

		return $num_letradmm;
	}

	private function cienmillon($numcmeros){
		if ($numcmeros == 100000000)
			$num_letracms = "CIEN MILLONES";
		if ($numcmeros >= 100000000 && $numcmeros <1000000000){
			$num_letracms = $this->centena(Floor($numcmeros/1000000))." MILLONES ".($this->millon($numcmeros%1000000));
		}
		if ($numcmeros < 100000000)
			$num_letracms = $this->decmillon($numcmeros);
		return $num_letracms;
	}

	private function milmillon($nummierod){
		if ($nummierod >= 1000000000 && $nummierod <2000000000){
			$num_letrammd = "MIL ".($this->cienmillon($nummierod%1000000000));
		}
		if ($nummierod >= 2000000000 && $nummierod <10000000000){
			$num_letrammd = $this->unidad(Floor($nummierod/1000000000))." MIL ".($this->cienmillon($nummierod%1000000000));
		}
		if ($nummierod < 1000000000)
			$num_letrammd = $this->cienmillon($nummierod);

		return $num_letrammd;
	}


	private function convertir($numero){
		     $num = str_replace(",","",$numero);
		     $num = number_format($num,2,'.','');
		     $cents = substr($num,strlen($num)-2,strlen($num)-1);
		     $num = (int)$num;

		     $numf = $this->milmillon($num);

		return " ".$numf." CON ".$cents."/100";
	}
}

