<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Microbanco_resumen extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('Microbanco_resumen_model', 'model');
    }

    function index()
    {
       $asesores = $this->model->get_cant_inscrip_xasesor();
       $evaluadores = $this->model->get_cant_inscrip_xavaluador();
       //$situaciones = $this->model->get_cant_inscrip_xsituacion();
       $situaciones = $this->model->get_cant_inscrip_xsituacion_general();

       $localidades = $this->model->get_cant_inscrip_xdepartamento();

       $localidades_monto = $this->model->localicad_monto_otorgado();
       $pagos = $this->model->get_resumen_pagos();
       $depositado = $this->model->get_total_depositado();
       $cant_creditos = $this->model->get_cant_creditos();



       //asesores
       $talabels = $tasdata = $tcolor = '';
    	foreach($asesores as $a)
        {
           $talabels        .= '"'.strtoupper($a['nom_ape']).'",';
           $tcolor        .= '"#17a2b8",';
           $tasdata  .= $a['cantidad']. ',';
        }
        $data['talabels'] = $talabels;
        $data['tasdata'] = $tasdata;
        $data['tascolor'] = $tcolor;

        //evaluadores
       $e_talabels = $e_tasdata = $e_tcolor = '';
    	foreach($evaluadores as $e)
        {
           $e_talabels        .= '"'.strtoupper($e['nom_ape']).'",';
           $e_tcolor        .= '"#28a745",';
           $e_tasdata  .= $e['cantidad']. ',';
        }
        $data['e_talabels'] = $e_talabels;
        $data['e_tasdata'] = $e_tasdata;
        $data['e_tascolor'] = $e_tcolor;


         //situaciones
       $s_talabels = $s_tasdata = $s_tcolor = '';
    	foreach($situaciones as $e)
        {
           $s_talabels        .= '"'.strtoupper($e['estado_nombre']).'",';
           $s_tcolor        .= '"'.$e['color_hex'].'",';
           $s_tasdata  .= $e['cantidad']. ',';
        }
        $data['s_talabels'] = $s_talabels;
        $data['s_tasdata'] = $s_tasdata;
        $data['s_tascolor'] = $s_tcolor;


          //localidades
       $l_talabels = $l_tasdata = $l_tcolor = '';
    	foreach($localidades as $l)
        {
           $l_talabels        .= '"'.strtoupper($l['localidad']).'",';
           $l_tcolor        .= '"#007bff",';
           $l_tasdata  .= $l['cantidad']. ',';
        }
        $data['l_talabels'] = $l_talabels;
        $data['l_tasdata'] = $l_tasdata;
        $data['l_tascolor'] = $l_tcolor;

            //localidades  monto otorgado
       $mo_talabels = $mo_tasdata = $mo_tcolor = '';
    	foreach($localidades_monto as $l)
        {
           $mo_talabels        .= '"'.strtoupper($l['localidad']).'",';
           $mo_tcolor        .= '"#007bff",';
           $mo_tasdata  .= $l['total_monto_otorgado']. ',';
        }
        $data['mo_talabels'] = $mo_talabels;
        $data['mo_tasdata'] = $mo_tasdata;
        $data['mo_tascolor'] = $mo_tcolor;

        $data['pagos']= $pagos;
        $data['depositado']= $depositado;
        $data['cant_creditos']= $cant_creditos[0]['cantidad_creditos'];
        $data['_view'] = 'microbanco/microbanco_resumen';
        $this->load->view('layouts/main',$data);
    }

     function info()
    {
       $situaciones = $this->model->get_cant_inscrip_xsituacion_general();

       $localidades_monto = $this->model->localicad_monto_otorgado();

       $localidades_inscrip_situacion = $this->model->localicad_cant_otorgado();



       $pagos = $this->model->get_resumen_pagos();
       $depositado = $this->model->get_total_depositado();
       $cant_creditos = $this->model->get_cant_creditos();

		$MesPasado = strtotime("last day of previous month");
		$date = date("Y-m-d", $MesPasado);
       //$date = date('Y-m-d');
       $exigible_depositado = $this->model->get_monto_exigible_depositado($date);
       $morosos = $this->model->get_creditos_morosos($date);

       //devuelve monto por ao y monto depositado
       $monto_por_anio = $this->model->get_monto_por_anio();

        //devuelve monto por ao y monto depositado hasta la fecha de corte.
       $monto_actual_anio = $this->model->get_monto_hasta_actual_por_anio($date);

       $asesor_estados = $this->model->get_asesor_estados_general();

        $data['pagos']= $pagos;
        $data['depositado']= $depositado;
        $data['cant_creditos']= $cant_creditos[0]['cantidad_creditos'];
        $data['exigible_depositado']=$exigible_depositado;
        $data['fecha_corte'] = date("d-m-Y", strtotime($date));
        $data['asesor_estados']=$asesor_estados;

        $data['localidad_monto']= $localidades_monto;
        $data['situaciones']= $situaciones;
        $data['localidad_situacion']= $localidades_inscrip_situacion;
        $data['morosos']= $morosos;
        $data['monto_por_anio']= $monto_por_anio;
        $data['monto_actual_anio']= $monto_actual_anio;
        $data['_view'] = 'microbanco/microbanco_resumen_info';
        $this->load->view('layouts/main',$data);
    }


    function info_deuda()
    {
    	$MesPasado = strtotime("last day of previous month");

		//$date = date("Y-m-d", $MesPasado);

       $date = date('Y-m-d');

       $morosos = $this->model->get_creditos_resumen_pagos($date);

       $data['fecha_corte'] = date("d-m-Y", strtotime($date));

       $data['asesor_estados']=$asesor_estados;

       $data['morosos']= $morosos;

       $data['_view'] = 'microbanco/microbanco_info_deuda';

       $this->load->view('layouts/main',$data);
    }
}
