<?php


class Obra extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('Obra_model', 'model');
    }

    /*
     * Listing of estados
     */
    function index()
    {
      if (!$this->ion_auth->in_group('obras_ver'))
      {
       redirect('/', 'refresh');
      }

      if(!empty($this->input->post('anio'))){
      	$this->session->set_userdata('obra_anio', $this->input->post('anio'));
      }

      $anio = $this->session->userdata('obra_anio');

      $data['obra_localidad'] =  '';
      $localidad = 0;
      if($this->input->post('localidad_id') > 0) {
        	$localidad = $this->input->post('localidad_id');
			$data['obra_localidad'] = $localidad;
	  }

	  $data['obra_departamento'] =  '';
      $departamento = 0;
      if($this->input->post('departamento_id') > 0) {
        	$departamento = $this->input->post('departamento_id');
			$data['obra_departamento'] = $departamento;
	  }


		$data['obra_x_anio'] = $anio;
        $data['obras'] = $this->model->get_all_obras($departamento, $localidad, $anio);
        $data['cant_obras']= count($data['obras']);
       // $data['pagos'] = $this->model->get_resumen_pagos($anio);
       // $data['depositado']= $this->model->get_total_depositado($anio);
       // $data['cant_finalizado']= $this->model->get_cantidad_finalizado($anio);

        $this->load->model('ObraLocalidad_model', 'locmodel');
		$data['all_localidades'] = $this->locmodel->get_all_localidades();

	 	$this->load->model('ObraDepartamento_model', 'dptomodel');
	 	$data['all_departamentos'] = $this->dptomodel->get_all_departamentos();

        $data['_view'] = 'obra/index';
        $this->load->view('layouts/main',$data);
    }

     function detalle($id = 0)
    {
    	if (!$this->ion_auth->in_group('obras_ver'))
      	{
       		redirect('/', 'refresh');
      	}
      	$data['obra'] = $this->model->get_obra_detalle($id);
      	$data['obrapersonas'] = $this->model->get_obra_personas($id);
      	$data['obraarchivos'] = $this->model->get_obra_archivos($id);
      	$data['obralicitacion'] = $this->model->get_all_obra_licitacion($id);
      	$data['obralicitacionproveedores'] = $this->model->get_obra_licitacion_proveedores($id);
      	$data['obraplazo'] = $this->model->get_all_obra_plazo($id);
      	$data['obrapresupuesto'] = $this->model->get_all_obra_presupuesto($id);
      	$data['obrainsumos'] = $this->model->get_all_obra_insumo($id);

     	$data['_view'] = 'obra/detalle';
      	$this->load->view('layouts/main',$data);
    }

     /*
     * Listing of estados
     */
    function add_index()
    {
    	if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        $data['obra'] = $this->model->get_agregar_all_obras();

        $data['_view'] = 'obra/add_index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new estado
     */
    function add()
    {
    	if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

    	 $this->load->library('form_validation');

         $this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');
         $this->form_validation->set_rules('inicio_proyecto','Fecha Inicio de Proyecto','required');
		 $this->form_validation->set_rules('obralocalidad_id','Localidad','required|greater_than[0]');
		 $this->form_validation->set_rules('anio','A&ntilde;o','required|greater_than[0]');
		 $this->form_validation->set_rules('obratipo_id','Tipo de Obra','required|greater_than[0]');
		 $this->form_validation->set_rules('obraprioridad_id','Prioridad','required|greater_than[0]');

          if($this->form_validation->run())
          {
           $params = array(
           		'descripcion' => $this->input->post('descripcion'),
				'expediente_nro' => $this->input->post('expediente_nro'),
				'inicio_proyecto' => $this->input->post('inicio_proyecto'),
				'obralocalidad_id' => $this->input->post('obralocalidad_id'),
				'anio' => $this->input->post('anio'),
				'obratipo_id' => $this->input->post('obratipo_id'),
				'obraprioridad_id' => $this->input->post('obraprioridad_id'),
				'observaciones' => $this->input->post('observaciones'),
				'created' => date("Y-m-d H:i:s"),
               );

                $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   '',
              	    'tipo_operacion' => 'add_obra',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              		);

           $obra_id = $this->model->add_obra($params);

           redirect('Obra/index');
       }
       else
       {

           $data['all_anios'] = array(array('id'=>(date("Y")-1) , 'anio'=>(date("Y")-1)),
           				   array('id'=>date("Y") , 'anio'=>date("Y")),
           				   array('id'=>(date("Y")+1) , 'anio'=>(date("Y")+1))
           				   );

       	 $this->load->model('ObraLocalidad_model', 'locmodel');
		$data['all_localidades'] = $this->locmodel->get_all_localidades();

	 	$this->load->model('ObraDepartamento_model', 'dptomodel');
	 	$data['all_departamentos'] = $this->dptomodel->get_all_departamentos();

	 	$this->load->model('ObraTipo_model');
		$data['all_obratipos'] = $this->ObraTipo_model->get_all_obratipos();

		$this->load->model('ObraPrioridad_model');
		$data['all_prioridades'] = $this->ObraPrioridad_model->get_all_prioridades();

           $data['_view'] = 'obra/add';
           $this->load->view('layouts/main',$data);
       }

    }

    /*
     * Editing a estado
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');
         	$this->form_validation->set_rules('inicio_proyecto','Fecha Inicio de Proyecto','required');
		 	$this->form_validation->set_rules('obralocalidad_id','Localidad','required|greater_than[0]');
		 	$this->form_validation->set_rules('anio','A&ntilde;o','required|greater_than[0]');
		 	$this->form_validation->set_rules('obratipo_id','Tipo de Obra','required|greater_than[0]');
		 	$this->form_validation->set_rules('obraprioridad_id','Prioridad','required|greater_than[0]');


            if($this->form_validation->run())
            {
                 $params = array(
           			'descripcion' => $this->input->post('descripcion'),
					'expediente_nro' => $this->input->post('expediente_nro'),
					'inicio_proyecto' => $this->input->post('inicio_proyecto'),
					'obralocalidad_id' => $this->input->post('obralocalidad_id'),
					'anio' => $this->input->post('anio'),
					'obratipo_id' => $this->input->post('obratipo_id'),
					'obraprioridad_id' => $this->input->post('obraprioridad_id'),
					'observaciones' => $this->input->post('observaciones'),
					'updated' => date("Y-m-d H:i:s"),
               );

               $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'edit_obra',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              		);

                $this->model->update_obra($id,$params);
                redirect('Obra/detalle/'. $id);
            }
            else
            {
            	  $data['all_anios'] = array(array('id'=>(date("Y")-1) , 'anio'=>(date("Y")-1)),
           				   array('id'=>date("Y") , 'anio'=>date("Y")),
           				   array('id'=>(date("Y")+1) , 'anio'=>(date("Y")+1))
           				   );

                $this->load->model('ObraLocalidad_model', 'locmodel');
				$data['all_localidades'] = $this->locmodel->get_all_localidades();

	 			//$this->load->model('ObraDepartamento_model', 'dptomodel');
	 			//$data['all_departamentos'] = $this->dptomodel->get_all_departamentos();

	 			$this->load->model('ObraTipo_model');
				$data['all_obratipos'] = $this->ObraTipo_model->get_all_obratipos();

				$this->load->model('ObraPrioridad_model');
				$data['all_prioridades'] = $this->ObraPrioridad_model->get_all_prioridades();

                $data['_view'] = 'obra/edit';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function add_persona($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrapersonatipo_id','Tipo','required');
		 	$this->form_validation->set_rules('obrapersona_id','Persona','required|greater_than[0]');

            if($this->form_validation->run())
            {
                 $params = array(
                 	'obra_id' => $id,
           			'obrapersona_id' => $this->input->post('obrapersona_id'),
					'obrapersonatipo_id' => $this->input->post('obrapersonatipo_id'),
					'fechadesde' => $this->input->post('fechadesde'),
					'fechahasta' => $this->input->post('fechahasta'),
					'created' => date("Y-m-d H:i:s"),
               );

               $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_persona',
              	    'datos'   =>  json_encode($params),
					'created' => date("Y-m-d H:i:s"),
              		);

                $this->model->add_persona($params);
                redirect('Obra/detalle/'. $id);
            }
            else
            {

	 			$this->load->model('ObraPersona_model');
				$data['all_personas'] = $this->ObraPersona_model->get_all_obrapersonas();

				$this->load->model('ObraPersonaTipo_model');
				$data['all_personatipos'] = $this->ObraPersonaTipo_model->get_all_obrapersonatipos();

                $data['_view'] = 'obra/add_persona';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function edit_persona($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obrapersonarel($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrapersonatipo_id','Tipo','required');
		 	$this->form_validation->set_rules('obrapersona_id','Nombre','required|greater_than[0]');

            if($this->form_validation->run())
            {
                 $params = array(
           			//'obrapersona_id' => $this->input->post('obrapersona_id'),
					'obrapersonatipo_id' => $this->input->post('obrapersonatipo_id'),
					'fechadesde' => $this->input->post('fechadesde'),
					'fechahasta' => $this->input->post('fechahasta'),
					'updated' => date("Y-m-d H:i:s"),
               );

                $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['obra']['obra_id'],
              	    'tipo_operacion' => 'edit_persona',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              		);

                $this->model->update_persona($id,$params);
                redirect('Obra/detalle/'. $data['obra']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraPersona_model');
				$data['all_personas'] = $this->ObraPersona_model->get_all_obrapersonas();

				$this->load->model('ObraPersonaTipo_model');
				$data['all_personatipos'] = $this->ObraPersonaTipo_model->get_all_obrapersonatipos();

                $data['_view'] = 'obra/edit_persona';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function add_archivo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obraarchivotipo_id','Tipo','required');
          	$this->form_validation->set_rules('descripcion','Descripci&oacute;m del Archivo','required');

            if($this->form_validation->run())
            {
            	$config['upload_path']   = './uploads/';
         		$config['allowed_types'] = 'jpg|png|pdf';
         		$config['max_size']      = 2048;   /*2M*/
         		$config['overwrite'] 	= false;
         		//$config['max_width']     = 1024;
         		//$config['max_height']    = 768;
         		$this->load->library('upload', $config);



         		if ( ! $this->upload->do_upload('filename')) {
            		$error = array('error' => $this->upload->display_errors());
            		//$this->load->view('upload_form', $error);
         		}
        		else {
            		$data = array('upload_data' => $this->upload->data());

            		//var_dump($data);
            		//exit;


            		 $params = array(
                 		'obra_id' => $id,
						'obraarchivotipo_id' => $this->input->post('obraarchivotipo_id'),
						'descripcion' => $this->input->post('descripcion'),
						'filename' => $data['upload_data']['file_name'],
						'fecha' => date("Y-m-d"),
						'user_id' => $this->session->userdata('user_id'),
						'user_nombre' => $this->session->userdata('name'),
						'created' => date("Y-m-d H:i:s"),
              		 );

              		 $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_archivo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              		);

                $this->model->add_archivo($params);
            		//$this->load->view('upload_success', $data);
         		}
                redirect('Obra/detalle/'. $id);
            }
            else
            {
				$this->load->model('ObraArchivoTipo_model');
				$data['all_archivotipos'] = $this->ObraArchivoTipo_model->get_all_obrasarchivostipos();

                $data['_view'] = 'obra/add_archivo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }


       function edit_archivo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['archivo'] = $this->model->get_obra_archivo($id);

        if(isset($data['archivo']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obraarchivotipo_id','Tipo','required');
          	$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');

            if($this->form_validation->run())
            {
              $params = array(
					'obraarchivotipo_id' => $this->input->post('obraarchivotipo_id'),
					'descripcion'  => $this->input->post('descripcion'),
					'updated' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['archivo']['obra_id'],
              	    'tipo_operacion' => 'edit_archivo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_archivo($id, $params);

                redirect('Obra/detalle/'. $data['archivo']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraArchivoTipo_model');
				$data['all_archivotipos'] = $this->ObraArchivoTipo_model->get_all_obrasarchivostipos();

                $data['_view'] = 'obra/edit_archivo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

       function download_archivo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['archivo'] = $this->model->get_obra_archivo($id);

        if(isset($data['archivo']['id']))
        {

	        $fileName = basename($data['archivo']['filename']);
			$filePath = 'uploads/'.$fileName;
			if(!empty($fileName) && file_exists($filePath)){
			    // Define headers
			    header("Cache-Control: public");
			    header("Content-Description: File Transfer");
			    header("Content-Disposition: attachment; filename=$fileName");
			    header("Content-Type: application/zip");
			    header("Content-Transfer-Encoding: binary");

			    // Read the file
			    readfile($filePath);
			    exit;
			}else{
			    echo 'El Archivo no Existe.';
			}
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }


      function add_licitacion($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrascategoriaslicitacion_id','Tipo de Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('nro','N&uacute;mero','required');
          	$this->form_validation->set_rules('anio','A&ntilde;o','required');
          	$this->form_validation->set_rules('fecha_concurso','Fecha Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('hora_concurso','Hora Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('lugar_apertura','Lugar Licitaci&oacute;n','required');

            if($this->form_validation->run())
            {
            	$params = array(
                 	'obra_id' => $id,
					'obrascategoriaslicitacion_id' => $this->input->post('obrascategoriaslicitacion_id'),
					'nro'  => $this->input->post('nro'),
					'anio'  => $this->input->post('anio'),
					'fecha_concurso'  => $this->input->post('fecha_concurso'),
					'hora_concurso'  => $this->input->post('hora_concurso'),
					'lugar_apertura'  => $this->input->post('lugar_apertura'),
					'observaciones'  => $this->input->post('observaciones'),
					'created' => date("Y-m-d H:i:s"),
              	);

              	$auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_licitacion',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->add_licitacion($params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
				$this->load->model('ObraCategoriaLicitacion_model');
				$data['all_categoriaslicitacion'] = $this->ObraCategoriaLicitacion_model->get_all_obracategoriaslicitaciones();

                $data['_view'] = 'obra/add_licitacion';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function edit_licitacion($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['licitacion'] = $this->model->get_obra_licitacion($id);

        if(isset($data['licitacion']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrascategoriaslicitacion_id','Tipo de Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('nro','N&uacute;mero','required');
          	$this->form_validation->set_rules('anio','A&ntilde;o','required');
          	$this->form_validation->set_rules('fecha_concurso','Fecha Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('hora_concurso','Hora Licitaci&oacute;n','required');
          	$this->form_validation->set_rules('lugar_apertura','Lugar Licitaci&oacute;n','required');

            if($this->form_validation->run())
            {
              $params = array(
					'obrascategoriaslicitacion_id' => $this->input->post('obrascategoriaslicitacion_id'),
					'nro'  => $this->input->post('nro'),
					'anio'  => $this->input->post('anio'),
					'fecha_concurso'  => $this->input->post('fecha_concurso'),
					'hora_concurso'  => $this->input->post('hora_concurso'),
					'lugar_apertura'  => $this->input->post('lugar_apertura'),
					'observaciones'  => $this->input->post('observaciones'),
					'modified' => date("Y-m-d H:i:s"),
              	);

              	$auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['licitacion']['obra_id'],
              	    'tipo_operacion' => 'edit_licitacion',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_licitacion($id, $params);

                redirect('Obra/detalle/'. $data['licitacion']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraCategoriaLicitacion_model');
				$data['all_categoriaslicitacion'] = $this->ObraCategoriaLicitacion_model->get_all_obracategoriaslicitaciones();


                $data['_view'] = 'obra/edit_licitacion';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function anular_licitacion($id)
    {
      if (!$this->ion_auth->in_group('obras_admin'))
      {
       redirect('/', 'refresh');
      }
      $obra = $this->model->get_obra_licitacion($id);

        // check if the estado exists before trying to delete it
        if(isset($obra['id']))
        {
            $params = array('anulado'=>1,'anulado_fecha'=>date('Y-m-d H:i:s'));

             $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $obra['obra_id'],
              	    'tipo_operacion' => 'anular_licitacion',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

            $obra_update = $this->model->update_licitacion($id, $params);

            redirect('Obra/detalle/'.$obra['obra_id']);
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando finalizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function ver_licitacion($id)
    {
    	if (!$this->ion_auth->in_group('obras_ver'))
      	{
       		redirect('/', 'refresh');
      	}

		if (is_numeric($id) && $id > 0) {
      		$data['licitacion'] = $this->model->get_ver_obra_licitacion($id);
      		$data['proveedores'] = $this->model->get_ver_obra_licitacion_proveedores($id);

     		$data['_view'] = 'obra/detalle_licitacion';
      		$this->load->view('layouts/main',$data);
      	}else {
      		redirect('Obra/index');
      	}
    }

    function add_oferta($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['licitacion'] = $this->model->get_obra_licitacion($id);

        if(isset($data['licitacion']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrasproveedor_id','Proveedor','required');
          	$this->form_validation->set_rules('sobreNro','Sobre N&uacute;mero','required');
          //	$this->form_validation->set_rules('polizaNro','P&oacute;liza Nro','required');
         // 	$this->form_validation->set_rules('polizaMonto','P&oacute;liza Monto','required');
          	$this->form_validation->set_rules('monto_oficial','Monto de la Oferta','required');


            if($this->form_validation->run())
            {
                $verificar = $this->input->post('rechazado');
                $rechazar = 0;
                if ($verificar == 1){
                    $rechazar = 1;
                 }

            	$params = array(
                 	'obraslicitacion_id' => $id,
					'obrasproveedor_id' => $this->input->post('obrasproveedor_id'),
					'sobreNro'  => $this->input->post('sobreNro'),
					'polizaNro'  => $this->input->post('polizaNro'),
					'polizaMonto'  => $this->input->post('polizaMonto'),
					'monto_oficial'  => $this->input->post('monto_oficial'),
					'rechazado'		=> $rechazar,
					'observaciones'  => $this->input->post('observaciones'),
					'created' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_oferta',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->add_oferta($params);

                redirect('Obra/detalle/'. $data['licitacion']['obra_id']);
            }
            else
            {
				$this->load->model('ObraProveedor_model');
				$data['all_proveedores'] = $this->ObraProveedor_model->get_all_obraproveedores();

                $data['_view'] = 'obra/add_oferta';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function edit_oferta($idlic)
    {
       // if (!$this->ion_auth->in_group('obras_admin'))
	   //   {
	   //    redirect('/', 'refresh');
	   //   }

        // check if the estado exists before trying to edit it
        $data['oferta'] = $this->model->get_obra_licitacion_apertura($idlic);

        if(isset($data['oferta']['id']))
        {

            $this->load->library('form_validation');

            $this->form_validation->set_rules('obrasproveedor_id','Proveedor','required');
            $this->form_validation->set_rules('sobreNro','Sobre N&uacute;mero','required');
          //  $this->form_validation->set_rules('polizaNro','P&oacute;liza Nro','required');
           // $this->form_validation->set_rules('polizaMonto','P&oacute;liza Monto','required');
            $this->form_validation->set_rules('monto_oficial','Monto de la Oferta','required');

            if($this->form_validation->run())
            {
                $verificar = $this->input->post('rechazado');
                $rechazar = 0;
                if ($verificar == 1){
                    $rechazar = 1;
                 }

              $params = array(
					'obrasproveedor_id' => $this->input->post('obrasproveedor_id'),
					'sobreNro'  => $this->input->post('sobreNro'),
					'polizaNro'  => $this->input->post('polizaNro'),
					'polizaMonto'  => $this->input->post('polizaMonto'),
					'monto_oficial'  => $this->input->post('monto_oficial'),
					'rechazado'		=> $rechazar,
					'observaciones'  => $this->input->post('observaciones'),
					'modified' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['oferta']['obra_id'],
              	    'tipo_operacion' => 'edit_oferta',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_oferta($id, $params);

                redirect('Obra/detalle/'. $data['oferta']['obra_id']);
            }
            else
            {

                $this->load->model('ObraProveedor_model');
				$data['all_proveedores'] = $this->ObraProveedor_model->get_all_obraproveedores();

                $data['_view'] = 'obra/edit_oferta';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function add_plazo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrasplazotipo_id','Tipo','required');
          	$this->form_validation->set_rules('cantidaddias','Cantidad de D&iacute;as','required');


            if($this->form_validation->run())
            {
            	$params = array(
                 	'obra_id' => $id,
					'obrasplazotipo_id' => $this->input->post('obrasplazotipo_id'),
					'cantidaddias'  => $this->input->post('cantidaddias'),
					'fechadesde'  => $this->input->post('fechadesde'),
					'fechahasta'  => $this->input->post('fechahasta'),
					'observaciones'  => $this->input->post('observaciones'),
					'created' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_plazo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->add_obraplazo($params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
				$this->load->model('ObraPlazoTipo_model');
				$data['all_plazos'] = $this->ObraPlazoTipo_model->get_all_obraplazotipos();

                $data['_view'] = 'obra/add_plazo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function edit_plazo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['plazo'] = $this->model->get_obra_plazo($id);

        if(isset($data['plazo']['id']))
        {

            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrasplazotipo_id','Tipo','required');
          	$this->form_validation->set_rules('cantidaddias','Cantidad de D&iacute;as','required');

            if($this->form_validation->run())
            {
              $params = array(
					'obrasplazotipo_id' => $this->input->post('obrasplazotipo_id'),
					'cantidaddias'  => $this->input->post('cantidaddias'),
					'fechadesde'  => $this->input->post('fechadesde'),
					'fechahasta'  => $this->input->post('fechahasta'),
					'observaciones'  => $this->input->post('observaciones'),
					'modified' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['plazo']['obra_id'],
              	    'tipo_operacion' => 'edit_plazo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_plazo($id, $params);

                redirect('Obra/detalle/'. $data['plazo']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraPlazoTipo_model');
				$data['all_plazos'] = $this->ObraPlazoTipo_model->get_all_obraplazotipos();

                $data['_view'] = 'obra/edit_plazo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

       function add_presupuesto($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obraspresupuestotipos_id','Tipo','required');
          	$this->form_validation->set_rules('monto','Monto','required');

            if($this->form_validation->run())
            {
            	$params = array(
                 	'obra_id' => $id,
					'obraspresupuestotipos_id' => $this->input->post('obraspresupuestotipos_id'),
					'monto'  => $this->input->post('monto'),
					'observaciones'  => $this->input->post('observaciones'),
					'created' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_presupuesto',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->add_obrapresupuesto($params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
				$this->load->model('ObraPresupuestoTipo_model');
				$data['all_presupuestostipos'] = $this->ObraPresupuestoTipo_model->get_all_obrapresupuestotipos();

                $data['_view'] = 'obra/add_presupuesto';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function edit_presupuesto($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['presupuesto'] = $this->model->get_obra_presupuesto($id);

        if(isset($data['presupuesto']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obraspresupuestotipos_id','Tipo','required');
          	$this->form_validation->set_rules('monto','Monto','required');

            if($this->form_validation->run())
            {
              $params = array(
					'obraspresupuestotipos_id' => $this->input->post('obraspresupuestotipos_id'),
					'monto'  => $this->input->post('monto'),
					'observaciones'  => $this->input->post('observaciones'),
					'updated' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['presupuesto']['obra_id'],
              	    'tipo_operacion' => 'edit_presupuesto',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_presupuesto($id, $params);

                redirect('Obra/detalle/'. $data['presupuesto']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraPresupuestoTipo_model');
				$data['all_presupuestostipos'] = $this->ObraPresupuestoTipo_model->get_all_obrapresupuestotipos();

                $data['_view'] = 'obra/edit_presupuesto';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    function edit_obrainicio($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');
          	$this->form_validation->set_rules('fecha_iniciodeobra','Fecha Inicio Obra','required');

            if($this->form_validation->run())
            {
              $params = array(
					'fecha_iniciodeobra'  => $this->input->post('fecha_iniciodeobra'),
					'obrainicio_obs'  => $this->input->post('obrainicio_obs'),
					'updated' => date("Y-m-d H:i:s"),
              	);

              $auditoria = array(
              	    'obra_id' => $id,
              	    'tipo_operacion' => 'edit_obrainicio',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_obra($id, $params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
                $data['_view'] = 'obra/edit_inicioobra';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function edit_obrafinalizacion($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');
          	$this->form_validation->set_rules('fecha_finalizaciondeobra','Fecha Finalizaci&oacute;n de Obra','required');

            if($this->form_validation->run())
            {
              $params = array(
              		'finalizado' => 1,
					'fecha_finalizaci1ondeobra'  => $this->input->post('fecha_finalizaciondeobra'),
					'obrafinalizacion_obs'  => $this->input->post('obrafinalizacion_obs'),
					'updated' => date("Y-m-d H:i:s"),
              	);

              $auditoria = array(
              	    'obra_id' => $id,
              	    'tipo_operacion' => 'edit_obrafinalizacion',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_obra($id, $params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
                $data['_view'] = 'obra/edit_obrafinalizacion';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    /*
     * Deleting estado
     */
    function remove($id)
    {
      if (!$this->ion_auth->in_group('admin'))
      {
       redirect('/', 'refresh');
      }
      $obra = $this->model->get_obra($id);

        // check if the estado exists before trying to delete it
        if(isset($obra['id']))
        {
            $this->model->delete_obra($id);
            redirect('Obra/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('obra/index');
        }
    }

        function add_insumo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['obra'] = $this->model->get_obra($id);

        if(isset($data['obra']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrainsumoestado_id','Estado','required');
          	$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');

            if($this->form_validation->run())
            {
            	$params = array(
                 	'obra_id' => $id,
                 	'descripcion'  => $this->input->post('descripcion'),
					'obrainsumoestado_id' => $this->input->post('obrainsumoestado_id'),
					'observaciones'  => $this->input->post('observaciones'),
					'created' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => '',
              	    'obra_id' =>   $id,
              	    'tipo_operacion' => 'add_insumo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->add_obrainsumo($params);

                redirect('Obra/detalle/'. $id);
            }
            else
            {
				$this->load->model('ObraInsumoEstado_model');
				$data['all_obrainsumoestados'] = $this->ObraInsumoEstado_model->get_all_obrainsumoestados();

                $data['_view'] = 'obra/add_insumo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando agregar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

     function edit_insumo($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        // check if the estado exists before trying to edit it
        $data['insumo'] = $this->model->get_obra_insumo($id);

        if(isset($data['insumo']['id']))
        {
            $this->load->library('form_validation');

          	$this->form_validation->set_rules('obrainsumoestado_id','Estado','required');
          	$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');

            if($this->form_validation->run())
            {
              $params = array(
					'obrainsumoestado_id' => $this->input->post('obrainsumoestado_id'),
					'descripcion'  => $this->input->post('descripcion'),
					'observaciones'  => $this->input->post('observaciones'),
					'updated' => date("Y-m-d H:i:s"),
              	);

              	 $auditoria = array(
              	    'ingreso_id' => $id,
              	    'obra_id' =>   $data['insumo']['obra_id'],
              	    'tipo_operacion' => 'edit_insumo',
              	    'datos'   =>  json_encode($params),
					'user_id' => $this->session->userdata('user_id'),
					'user_nombre' => $this->session->userdata('name'),
					'created' => date("Y-m-d H:i:s"),
              	);

                $this->model->update_obrainsumo($id, $params);

                redirect('Obra/detalle/'. $data['insumo']['obra_id']);
            }
            else
            {

	 			$this->load->model('ObraInsumoEstado_model');
				$data['all_obrainsumoestados'] = $this->ObraInsumoEstado_model->get_all_obrainsumoestados();

                $data['_view'] = 'obra/edit_insumo';
                $this->load->view('layouts/main',$data);
            }
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

    private function dias_pasados($fecha_inicial,$fecha_final)
	{
		$dias = (strtotime($fecha_inicial)-strtotime($fecha_final))/86400;
		//$dias = abs($dias); $dias = floor($dias);
		return $dias;
	}

}
