<?php

class ObraInsumoEstado extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('ObraInsumoEstado_model', 'model');
    }

    /*
     * Listing of Tipos de Obra
     */
    function index()
    {
       if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $data['obratipos'] = $this->model->get_all_obrainsumoestados();

        $data['_view'] = 'obrainsumoestado/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new Tipo de Obra
     */
    function add()
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        $this->load->library('form_validation');

        $this->form_validation->set_rules('title','Estado','required');

        var_dump($this->input->post());



        if($this->form_validation->run())
        {
            $params = array(
				'title' => $this->input->post('title'),
				'color' => $this->input->post('color'),
				'created' => date("Y-m-d H:i:s"),
            );

            $estado_id = $this->model->add_obrainsumoestado($params);
            redirect('ObraInsumoEstado/index');
        }
        else
        {

            $data['_view'] = 'obrainsumoestado/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a Tipo de Obra
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['tipo'] = $this->model->get_obrainsumoestado($id);

        if(isset($data['tipo']['id']))
        {
           $this->load->library('form_validation');

          	$this->form_validation->set_rules('title','Estado','required');


            if($this->form_validation->run())
            {
                $params = array(
				'title' => $this->input->post('title'),
				'color' => $this->input->post('color'),
				'updated' => date("Y-m-d H:i:s"),
           		 );

                $this->model->update_obrainsumoestado($id,$params);
                redirect('ObraInsumoEstado/index');
            }
            else
            {
                $data['_view'] = 'obrainsumoestado/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('ObraInsumoEstado/index');
        }
    }

    /*
     * Deleting Tipo de Obra
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $obratipo = $this->model->get_obrainsumoestado($id);

        // check if the estado exists before trying to delete it
        if(isset($obratipo['id']))
        {
            $this->model->delete_obrainsumoestado($id);
            redirect('ObraInsumoEstado/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Eliminar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

}
