<?php

class ObraLocalidad extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('ObraLocalidad_model', 'model');
    }

    /*
     * Listing of estados
     */
    function index()
    {
       if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $data['obralocalidades'] = $this->model->get_all_localidades();

        $data['_view'] = 'obralocalidad/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new estado
     */
    function add()
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        $this->load->library('form_validation');

        $this->form_validation->set_rules('localidad','Localidad','required');
        $this->form_validation->set_rules('departamento_id','Departamento','required');

        if($this->form_validation->run())
        {
            $params = array(
				'localidad' => $this->input->post('localidad'),
				'departamento_id' => $this->input->post('departamento_id'),
				'created' => date("Y-m-d H:i:s"),
            );

            $estado_id = $this->model->add_localidad($params);
            redirect('ObraLocalidad/index');
        }
        else
        {
            $this->load->model('ObraDepartamento_model');
			$data['all_departamentos'] = $this->ObraDepartamento_model->get_all_departamentos();

            $data['_view'] = 'obralocalidad/add';
            $this->load->view('layouts/main',$data);
        }
    }

    function add_departamento()
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        $this->load->library('form_validation');

        $this->form_validation->set_rules('departamento','Departamento','required');

        if($this->form_validation->run())
        {
            $params = array(
				'departamento' => $this->input->post('departamento'),
				'created' => date("Y-m-d H:i:s"),
            );

            $estado_id = $this->model->add_departamento($params);
            redirect('ObraLocalidad/index');
        }
        else
        {

            $data['_view'] = 'obralocalidad/add_departamento';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a estado
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['localidad'] = $this->model->get_localidad($id);

        if(isset($data['localidad']['id']))
        {
           $this->load->library('form_validation');

          	$this->form_validation->set_rules('localidad','Localidad','required');
            $this->form_validation->set_rules('departamento_id','Departamento','required');


            if($this->form_validation->run())
            {
                $params = array(
				'localidad' => $this->input->post('localidad'),
				'departamento_id' => $this->input->post('departamento_id'),
				'updated' => date("Y-m-d H:i:s"),
           		 );

                $this->model->update_localidad($id,$params);
                redirect('ObraLocalidad/index');
            }
            else
            {
                $this->load->model('ObraDepartamento_model');
                $data['all_departamentos'] = $this->ObraDepartamento_model->get_all_departamentos();

                $data['_view'] = 'obralocalidad/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('ObraLocalidad/index');
        }
    }

    /*
     * Deleting estado
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $obralocalidad = $this->model->get_localidad($id);

        // check if the estado exists before trying to delete it
        if(isset($obralocalidad['id']))
        {
            $this->model->delete_localidad($id);
            redirect('ObraLocalidad/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Eliminar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

}
