<?php

class ObraProveedor extends CI_Controller{
    function __construct()
    {
        parent::__construct();

       	if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('ObraProveedor_model', 'model');
    }

    /*
     * Listing of estados
     */
    function index()
    {
       if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $data['obraproveedores'] = $this->model->get_all_obraproveedores();

        $data['_view'] = 'obraproveedor/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new estado
     */
    function add()
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }

        $this->load->library('form_validation');

        $this->form_validation->set_rules('title','Nombre','required');

         $activo = empty($this->input->post('activo'))? 0 : $this->input->post('activo');

        if($this->form_validation->run())
        {
            $params = array(
				'title' => $this->input->post('title'),
				'cuit' => $this->input->post('cuit'),
				'email' => $this->input->post('email'),
				'cel' => $this->input->post('cel'),
				'domicilio' => $this->input->post('domicilio'),
				'localidad' => $this->input->post('localidad'),
				'provincia' => $this->input->post('provincia'),
				'activo' => $activo,
				'created' => date("Y-m-d H:i:s"),
            );

            $estado_id = $this->model->add_obraproveedor($params);
            redirect('ObraProveedor/index');
        }
        else
        {
            $data['_view'] = 'obraproveedor/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a estado
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        // check if the estado exists before trying to edit it
        $data['proveedor'] = $this->model->get_obraproveedor($id);

        if(isset($data['proveedor']['id']))
        {
           $this->load->library('form_validation');

          	$this->form_validation->set_rules('title','Nombre','required');

          	 $activo = empty($this->input->post('activo'))? 0 : $this->input->post('activo');

            if($this->form_validation->run())
            {
                $params = array(
                'title' => $this->input->post('title'),
				'cuit' => $this->input->post('cuit'),
				'email' => $this->input->post('email'),
				'cel' => $this->input->post('cel'),
				'domicilio' => $this->input->post('domicilio'),
				'localidad' => $this->input->post('localidad'),
				'provincia' => $this->input->post('provincia'),
				'activo' => $activo,
				'updated' => date("Y-m-d H:i:s"),
           		 );

                $this->model->update_obraproveedor($id,$params);
                redirect('ObraProveedor/index');
            }
            else
            {
                $data['_view'] = 'obraproveedor/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Actualizar no existe o no tienes los permisos para su acceso.');
            redirect('ObraProveedor/index');
        }
    }

    /*
     * Deleting estado
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('obras_admin'))
	      {
	       redirect('/', 'refresh');
	      }
        $obrapersona = $this->model->get_obraproveedor($id);

        // check if the estado exists before trying to delete it
        if(isset($obrapersona['id']))
        {
            $this->model->delete_obraproveedor($id);
            redirect('ObraProveedor/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando Eliminar no existe o no tienes los permisos para su acceso.');
            redirect('Obra/index');
        }
    }

}
