<?php

class Vehiculo_autorizacion extends CI_Controller{
    function __construct()
    {
        parent::__construct();

        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

        $this->load->model('Vehiculo_autorizacion_model', 'model');
    }

    /*
     * Listing of personas
     */
    function index()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['personas'] = $this->model->get_all_personas();

        $data['_view'] = 'vehiculo_autorizacion/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new persona
     */
    function add()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $this->load->library('form_validation');

		$this->form_validation->set_rules('nom_ape','Apellido y Nombre','required');
		$this->form_validation->set_rules('dni','DNI','required');

		if($this->form_validation->run())
        {
            $params = array(
                'nom_ape' => $this->input->post('nom_ape'),
                'dni' => $this->input->post('dni'),
                'observaciones' => $this->input->post('observaciones'),
				'activo' => $this->input->post('activo'),
            );

            $persona_id = $this->model->add_persona($params);
            redirect('vehiculo_autorizacion/index');
        }
        else
        {
            $data['_view'] = 'vehiculo_autorizacion/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a persona
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        // check if the persona exists before trying to edit it
        $data['persona'] = $this->model->get_persona($id);

        if(isset($data['persona']['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('nom_ape','Apellido y Nombre','required');
			$this->form_validation->set_rules('dni','DNI','required');

			if($this->form_validation->run())
            {
                $params = array(
                'nom_ape' => $this->input->post('nom_ape'),
                'dni' => $this->input->post('dni'),
                'observaciones' => $this->input->post('observaciones'),
				'activo' => $this->input->post('activo'),
            	);

                $this->model->update_persona($id,$params);
                redirect('vehiculo_autorizacion/index');
            }
            else
            {
                $data['_view'] = 'vehiculo_autorizacion/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculo_autorizacion/index');
        }
    }

    /*
     * Deleting persona
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $persona = $this->model->get_persona($id);

        // check if the persona exists before trying to delete it
        if(isset($persona['id']))
        {
            $params = array('isDelete'=>1,'deleteFecha'=>date('Y-m-d H:i:s'));
            $persona = $this->model->update_persona($id, $params);
            redirect('vehiculo_autorizacion/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculo_autorizacion/index');
        }
    }

}
