<?php


class Vehiculo_tipo_evento extends CI_Controller{
    function __construct()
    {
        parent::__construct();

        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }
        $this->load->model('Vehiculo_tipo_evento_model', 'model');
    }

    /*
     * Listing of localidades
     */
    function index()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['eventos'] = $this->model->get_all();

        $data['_view'] = 'vehiculo_tipo_evento/index';
        $this->load->view('layouts/main',$data);
    }

    /*
     * Adding a new localidad
     */
    function add()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $this->load->library('form_validation');

		$this->form_validation->set_rules('nombre','Nombre','required');

		if($this->form_validation->run())
        {
            $params = array(
				'nombre' => $this->input->post('nombre'),
            );

            $tipo_id = $this->model->add_tipo($params);
            redirect('vehiculo_tipo_evento/index');
        }
        else
        {

            $data['_view'] = 'vehiculo_tipo_evento/add';
            $this->load->view('layouts/main',$data);
        }
    }

    /*
     * Editing a localidad
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        // check if the localidad exists before trying to edit it
        $data['evento'] = $this->model->get_tipo($id);

        if(isset($data['evento']['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('nombre','Nombre','required');

			if($this->form_validation->run())
            {
                $params = array(
					'nombre' => $this->input->post('nombre'),
                );

                $this->model->update_tipo($id,$params);
                redirect('vehiculo_tipo_evento/index');
            }
            else
            {
            	$data['_view'] = 'vehiculo_tipo_evento/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculo_tipo_eventon/index');
        }
    }

}
