<?php


class Vehiculos extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        $this->load->model('Vehiculo_model', 'model');
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

    }

    /*
     * Listing of notas_calefones
     */
    function index()
    {
    	if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculos'] = $this->model->get_all_vehiculos();

        $data['_view'] = 'vehiculo/index';
        $this->load->view('layouts/main',$data);
    }



    function detalle($id)
    {

        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}

         $data['vehiculo'] = $this->model->get_vehiculo($id);
         $data['vehiculo_historial'] = $this->model->get_vehiculo_historial_activo($id);

		$titulo = '';
		if(isset($data['vehiculo']['id']))
        {
          $titulo =  $data['vehiculo']['patente'] . ' - ' . $data['vehiculo']['marca'];
        }

         $data['title_for_layout'] = 'CAFESG: Gesti&oacute;n de Vehiculos - '. $titulo;
        $data['_view'] = 'vehiculo/detalle';

        $this->load->view('layouts/main',$data);

    }

    /*
     * Adding a new notas_calefon
     */
    function add()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $this->load->library('form_validation');

		$this->form_validation->set_rules('patente','Patente','required');
		$this->form_validation->set_rules('marca','Marca','required');
		$this->form_validation->set_rules('modelo','Modelo','required');
		$this->form_validation->set_rules('anio','A&ntilde;o','required|integer');

		 $tarjeta_verde = empty($this->input->post('tarjeta_verde'))? 0 : $this->input->post('tarjeta_verde');
		 $balizas = empty($this->input->post('balizas'))? 0 : $this->input->post('balizas');
		 $chaleco = empty($this->input->post('chaleco'))? 0 : $this->input->post('chaleco');
		 $gancho_remolque = empty($this->input->post('gancho_remolque'))? 0 : $this->input->post('gancho_remolque');


		if($this->form_validation->run())
        {
            $params = array(
            	'patente' => $this->input->post('patente'),
				'marca' => $this->input->post('marca'),
				'modelo' => $this->input->post('modelo'),
				'anio' => $this->input->post('anio'),
				'tarjeta_verde' => $tarjeta_verde,
				'balizas' => $balizas,
				'chaleco' => $chaleco,
				'gancho_remolque' =>  $gancho_remolque,
				'created'=> date('Y-m-d H:i:s'),
            );

            $vehiculo_id = $this->model->add_vehiculo($params);
            redirect('vehiculos/index');
        }
        else
        {
			//$this->load->model('Calefones_inscripcion_model');
			//$data['all_calefones_inscripciones'] = $this->Calefones_inscripcion_model->get_all_calefones_inscripciones();

            $data['_view'] = 'vehiculo/add';
            $this->load->view('layouts/main',$data);
        }
    }

    function nueva_poliza($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo($id);

        if(isset($data['vehiculo']['id']))
        {
    		$this->load->library('form_validation');
			$this->form_validation->set_rules('poliza_nro','P&oacute;liza Nro','required');
			$this->form_validation->set_rules('poliza_fecha_desde','Fecha Desde','required');
			$this->form_validation->set_rules('poliza_fecha_hasta','Fecha Hasta','required');

			if($this->form_validation->run())
        	{
        		$params = array(
        		'vehiculo_id' => $id,
        		'tipo_evento' => 1,
        		'observacion' => 'P&oacute;liza Nro '.$this->input->post('poliza_nro'),
            	'descripcion' => 'P&oacute;liza Seguro Automotor',
				'fecha_desde' => $this->input->post('poliza_fecha_desde'),
				'fecha_hasta' => $this->input->post('poliza_fecha_hasta'),
				'activo' => 1,
				'created'=> date('Y-m-d H:i:s'),
            	);

            	$actualizar = array(
            		'seguro'=> 1,
            	 	'seguro_nro_vigente' => $this->input->post('poliza_nro'),
        			'seguro_fecha_venc' => $this->input->post('poliza_fecha_hasta'),
					'update'=> date('Y-m-d H:i:s'),
            	);

            	 $vehiculo_id = $this->model->agregar_actualizar_poliza_vehicular($params, $actualizar, $id);
                  redirect('vehiculos/detalle/'.$id);
        	}
       		else
        	{
            $data['_view'] = 'vehiculo/nueva_poliza';
            $this->load->view('layouts/main',$data);
        	}
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

     function edit_poliza($id_historial)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo_historial($id_historial);

        if(isset($data['vehiculo']['id']))
        {
    		$vehiculo_id = $data['vehiculo']['vehiculo_id'];
    		$this->load->library('form_validation');
    		$this->form_validation->set_rules('poliza_nro','P&oacute;liza Nro','required');
    		$this->form_validation->set_rules('poliza_fecha_desde','Fecha Desde','required');
			$this->form_validation->set_rules('poliza_fecha_hasta','Fecha Hasta','required');

			if($this->form_validation->run())
        	{

        		$act_historial = array(
        		'observacion' => 'P&oacute;liza Nro '.$this->input->post('poliza_nro'),
				'fecha_desde' => $this->input->post('poliza_fecha_desde'),
				'fecha_hasta' => $this->input->post('poliza_fecha_hasta'),
				'update'=> date('Y-m-d H:i:s'),
            	);

            	$act_vehiculo = array(
            		'seguro_nro_vigente' => $this->input->post('poliza_nro'),
        			'seguro_fecha_venc' => $this->input->post('poliza_fecha_hasta'),
					'update'=> date('Y-m-d H:i:s'),
            	);

                $vehiculo_id = $this->model->edit_vehiculo_historial($act_historial, $act_vehiculo, $id_historial, $vehiculo_id);
            	redirect('vehiculos/detalle/'.$vehiculo_id);
        	}
       		else
        	{
            $data['_view'] = 'vehiculo/edit_poliza';
            $this->load->view('layouts/main',$data);
        	}
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

     function nuevo_matafuegos($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo($id);

        if(isset($data['vehiculo']['id']))
        {
    		$this->load->library('form_validation');
    		$this->form_validation->set_rules('matafuego_fecha_desde','Fecha de Carga','required');
			$this->form_validation->set_rules('matafuego_fecha_hasta','Fecha Vencimiento','required');

			if($this->form_validation->run())
        	{
        		$params = array(
        		'vehiculo_id' => $id,
        		'tipo_evento' => 2,
        		'observacion' => '',
            	'descripcion' => 'Renovaci&oacute;n de Matafuegos',
				'fecha_desde' => $this->input->post('matafuego_fecha_desde'),
				'fecha_hasta' => $this->input->post('matafuego_fecha_hasta'),
				'activo' => 1,
				'created'=> date('Y-m-d H:i:s'),
            	);

            	$actualizar = array(
            		'matafuego'=> 1,
        			'matafuego_fecha_venc' => $this->input->post('matafuego_fecha_hasta'),
					'update'=> date('Y-m-d H:i:s'),
            	);

            	 $vehiculo_id = $this->model->agregar_actualizar_matafuego_vehicular($params, $actualizar, $id);
                  redirect('vehiculos/detalle/'.$id);
        	}
       		else
        	{
            $data['_view'] = 'vehiculo/nuevo_matafuego';
            $this->load->view('layouts/main',$data);
        	}
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

    function edit_matafuegos($id_historial)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo_historial($id_historial);

        if(isset($data['vehiculo']['id']))
        {
    		$vehiculo_id = $data['vehiculo']['vehiculo_id'];
    		$this->load->library('form_validation');
    		$this->form_validation->set_rules('matafuego_fecha_desde','Fecha de Carga','required');
			$this->form_validation->set_rules('matafuego_fecha_hasta','Fecha Vencimiento','required');

			if($this->form_validation->run())
        	{

        		$act_historial = array(
				'fecha_desde' => $this->input->post('matafuego_fecha_desde'),
				'fecha_hasta' => $this->input->post('matafuego_fecha_hasta'),
				'update'=> date('Y-m-d H:i:s'),
            	);

            	$act_vehiculo = array(
            		'matafuego'=> 1,
        			'matafuego_fecha_venc' => $this->input->post('matafuego_fecha_hasta'),
					'update'=> date('Y-m-d H:i:s'),
            	);

                $vehiculo_id = $this->model->edit_vehiculo_historial($act_historial, $act_vehiculo, $id_historial, $vehiculo_id);
            	redirect('vehiculos/detalle/'.$vehiculo_id);
        	}
       		else
        	{
            $data['_view'] = 'vehiculo/edit_matafuego';
            $this->load->view('layouts/main',$data);
        	}
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

     function mantenimiento($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo($id);

        if(isset($data['vehiculo']['id']))
        {
    		$this->load->library('form_validation');
    		$this->form_validation->set_rules('vehiculo_tipo_evento_id','Tipo de Evento','required');
			$this->form_validation->set_rules('fecha_desde','Fecha','required');
			$this->form_validation->set_rules('km','KM','required');

			if($this->form_validation->run())
        	{
        		$vehiculo_tipo_evento_id = $this->input->post('vehiculo_tipo_evento_id');
        		$params = array(
        		'vehiculo_id' => $id,
        		'tipo_evento' => 3,
        		'vehiculo_tipo_evento_id' => $vehiculo_tipo_evento_id,
        		'observacion' => $this->input->post('observacion'),
        		'km' => $this->input->post('km'),
            	'descripcion' => '',
				'fecha_desde' => $this->input->post('fecha_desde'),
				'fecha_hasta' => '00-00-0000',
				'activo' => 1,
				'created'=> date('Y-m-d H:i:s'),
            	);



            	if ($vehiculo_tipo_evento_id == 1){
            	    $params['descripcion']= 'Rotaci&oacute;n de Ruedas';

            	    $actualizar = array(
            		'rotacion_rueda'=> 1,
        			'rotacion_fecha' => $this->input->post('fecha_desde'),
					'update'=> date('Y-m-d H:i:s'),
            		);
            		 $vehiculo_id = $this->model->agregar_actualizar_mantenimiento($params, $actualizar, $id);
            	}else {
            	 	$vehiculo_id = $this->model->agregar_mantenimiento($params, $id);
            	 }
                 redirect('vehiculos/detalle/'.$id);
        	}
       		else
        	{
        		$this->load->model('Vehiculo_tipo_evento_model');
				$data['all_tipos'] = $this->Vehiculo_tipo_evento_model->get_all();

            	$data['_view'] = 'vehiculo/mantenimiento';
            	$this->load->view('layouts/main',$data);
        	}
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

      function mantenimiento_edit($id_historial)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculo'] = $this->model->get_vehiculo_historial($id_historial);

        if(isset($data['vehiculo']['id']))
        {
           	$vehiculo_id = $data['vehiculo']['vehiculo_id'];
    		$this->load->library('form_validation');
    		$this->form_validation->set_rules('vehiculo_tipo_evento_id','Tipo de Evento','required');
			$this->form_validation->set_rules('fecha_desde','Fecha','required');
			$this->form_validation->set_rules('km','KM','required');

			if($this->form_validation->run())
        	{


        		$vehiculo_tipo_evento_id = $this->input->post('vehiculo_tipo_evento_id');
        		$act_historial = array(
        		'vehiculo_tipo_evento_id' => $vehiculo_tipo_evento_id,
        		'observacion' => $this->input->post('observacion'),
        		'km' => $this->input->post('km'),
				'fecha_desde' => $this->input->post('fecha_desde'),
				'update'=> date('Y-m-d H:i:s'),
            	);



            	if ($vehiculo_tipo_evento_id == 1){
            	    $act_vehiculo = array(
            		'rotacion_rueda'=> 1,
        			'rotacion_fecha' => $this->input->post('fecha_desde'),
					'update'=> date('Y-m-d H:i:s'),
            		);
            		$vehiculo_id = $this->model->edit_vehiculo_historial($act_historial, $act_vehiculo, $id_historial, $vehiculo_id);
            	}else {
            	 	$vehiculo_id = $this->model->edit_historial($id_historial, $act_historial);
            	 }
                 redirect('vehiculos/detalle/'.$data['vehiculo']['vehiculo_id']);
        	}
       		else
        	{
        		$this->load->model('Vehiculo_tipo_evento_model');
				$data['all_tipos'] = $this->Vehiculo_tipo_evento_model->get_all();

            	$data['_view'] = 'vehiculo/mantenimiento_edit';
            	$this->load->view('layouts/main',$data);
        	}
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }

    }

    /*
     * Editing a notas_calefon
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
         // check if the notas_calefon exists before trying to edit it
        $data['vehiculo'] = $this->model->get_vehiculo($id);

        if(isset($data['vehiculo']['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('patente','Patente','required');
			$this->form_validation->set_rules('marca','Marca','required');
			$this->form_validation->set_rules('modelo','Modelo','required');
			$this->form_validation->set_rules('anio','A&ntilde;o','required|integer');

			 $balizas = empty($this->input->post('balizas'))? 0 : $this->input->post('balizas');
			 $chaleco = empty($this->input->post('chaleco'))? 0 : $this->input->post('chaleco');
			 $gancho_remolque = empty($this->input->post('gancho_remolque'))? 0 : $this->input->post('gancho_remolque');

			if($this->form_validation->run())
            {
                $params = array(
            	'patente' => $this->input->post('patente'),
				'marca' => $this->input->post('marca'),
				'modelo' => $this->input->post('modelo'),
				'anio' => $this->input->post('anio'),
				'balizas' => $balizas,
				'chaleco' => $chaleco,
				'gancho_remolque' =>  $gancho_remolque,
				'update'=> date('Y-m-d H:i:s'),
            	);

                $this->model->update_vehiculo($id,$params);
                redirect('vehiculos/index');
            }
            else
            {
				//$this->load->model('Calefones_inscripcion_model');
				//$data['all_calefones_inscripciones'] = $this->Calefones_inscripcion_model->get_all_calefones_inscripciones();

                $data['_view'] = 'vehiculo/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }
    }

    /*
     * Deleting notas_calefon
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $vehiculo = $this->model->get_vehiculo($id);

        // check if the notas_calefon exists before trying to delete it
        if(isset($vehiculo['id']))
        {
            $params = array('isDelete'=>1,'deleteFecha'=>date('Y-m-d H:i:s'));
            $vehiculo = $this->model->update_vehiculo($id, $params);
            redirect('vehiculos/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }
    }

     /*
     * Deleting notas_calefon
     */
    function mantenimiento_remove($id_historial)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}

        $vehiculo = $this->model->get_vehiculo_historial($id_historial);

        // check if the notas_calefon exists before trying to delete it
        if(isset($vehiculo['id']))
        {
            $id_vehiculo = $vehiculo['vehiculo_id'];
            $params = array('isDelete'=>1,'deleteFecha'=>date('Y-m-d H:i:s'));
            $vehiculo = $this->model->edit_historial($id_historial, $params);
            redirect('vehiculos/detalle/'.  $id_vehiculo);
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos/index');
        }
    }

     function ultimoevento($tipo_evento_id = 2)
    {

        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}

        $data['vehiculos'] = $this->model->get_vehiculo_ultimo_evento($tipo_evento_id);
		$titulo = '';
		if(isset($data['vehiculo']['id']))
        {
          $titulo =  $data['vehiculo']['patente'] . ' - ' . $data['vehiculo']['marca'];
        }

        $data['title_for_layout'] = 'CAFESG: Gesti&oacute;n de Vehiculos - '. $titulo;
        $data['_view'] = 'vehiculo/ultimoevento';

        $this->load->view('layouts/main',$data);

    }


}
