<?php


class Vehiculos_calendario extends CI_Controller{
    function __construct()
    {
        parent::__construct();
        $this->load->model('Vehiculo_calendario_model', 'model');
        if (!$this->ion_auth->logged_in())
	    {
	      redirect('auth/login');
	    }

    }

    /*
     * Listing of notas_calefones
     */
    function index()
    {
    	if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $data['vehiculos'] = $this->model->get_all_vehiculos_calendario();

        $data['_view'] = 'vehiculo_calendario/index';
        $this->load->view('layouts/main',$data);
    }

     function calendario()
    {
    	if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $vehiculos = $this->model->get_all_vehiculos_calendario();

        $eventos = '';
        $calendar = array();
        foreach ($vehiculos as $key => $e)
        {
          $calendar[] = array(
							'id' 	=> intval($e['id']),
							'title' => $e['patente']. '*-*'. $e['marca'] . ' - ' . $e['nom_ape'],
							'description' => trim($e['descripcion']),
							'start' => date_format( date_create($e['fecha_desde']) ,"Y-m-d H:i:s"),
							'end' 	=> date_format( date_create($e['fecha_hasta']) ,"Y-m-d H:i:s"),
							'url'    => 'index.html',
							'backgroundColor'  => $e['color_calendario'],
							'borderColor' => $e['color_calendario'],
							);
        }


        $data['eventos'] =json_encode($calendar);
        $data['_view'] = 'vehiculo_calendario/calendario';
        $this->load->view('layouts/main',$data);
    }


    function calendario_ajax()
    {

      if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}

      	if (!isset($_GET['start']) || !isset($_GET['end'])) {
         die("Proporcione un intervalo de fechas.");
        }

        $range_start = $_GET['start'];
        $range_end = $_GET['end'];

        $vehiculos = $this->model->get_all_vehiculos_calendario_ajax($range_start, $range_end);


        $eventos = '';
        $calendar = array();
        foreach ($vehiculos as $key => $e)
        {
          $calendar[] = array(
							'id' 	=> intval($e['id']),
							'title' => $e['patente']. '*-*'. $e['marca'] . ' - ' . $e['nom_ape'].' - ' . $e['descripcion'],
							'description' => trim($e['descripcion']),
							'start' => date_format( date_create($e['fecha_desde']) ,"Y-m-d H:i:s"),
							'allDay' => true,
							'backgroundColor'  => $e['color_calendario'],
							'borderColor' => $e['color_calendario'],
							);
        }

        echo json_encode($calendar);

    }


    /*
     * Adding a new notas_calefon
     */
    function add()
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $this->load->library('form_validation');

		$this->form_validation->set_rules('vehiculo_id','Vehiculo','required');
		$this->form_validation->set_rules('vehiculo_autorizacion_id','Persona Autorizada','required');
		$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');
		$this->form_validation->set_rules('fecha_desde','Fecha Desde','required');

		if($this->form_validation->run())
        {
           // $fecha_desde_hasta = explode("-", $this->input->post('fecha_desde_hasta'));

           // $date_desde = DateTime::createFromFormat('d/m/Y H:s', trim($fecha_desde_hasta[0]));
           // $date_hasta = DateTime::createFromFormat('d/m/Y H:s', trim($fecha_desde_hasta[1]));
           //'fecha_desde' => $date_desde->format('Y-m-d H:s'),
			//	'fecha_hasta' => $date_hasta->format('Y-m-d H:s'),

            $params = array(
            	'vehiculo_id' => $this->input->post('vehiculo_id'),
				'vehiculo_autorizacion_id' => $this->input->post('vehiculo_autorizacion_id'),
				'descripcion' => $this->input->post('descripcion'),
				'fecha_desde' => $this->input->post('fecha_desde'),
				'created'=> date('Y-m-d H:i:s'),
            );

            $vehiculo_id = $this->model->add_vehiculo_calendario($params);
            redirect('vehiculos_calendario/index');
        }
        else
        {
			$this->load->model('Vehiculo_autorizacion_model');
			$data['all_autorizaciones'] = $this->Vehiculo_autorizacion_model->get_all_personas();

			$this->load->model('Vehiculo_model');
			$data['all_vehiculos'] = $this->Vehiculo_model->get_all_vehiculos_select();

            $data['_view'] = 'vehiculo_calendario/add';
            $this->load->view('layouts/main',$data);
        }
    }




    /*
     * Editing a notas_calefon
     */
    function edit($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
         // check if the notas_calefon exists before trying to edit it
        $data['v_calendario'] = $this->model->get_vehiculo_calendario($id);

        if(isset($data['v_calendario']['id']))
        {
            $this->load->library('form_validation');

			$this->form_validation->set_rules('vehiculo_id','Vehiculo','required');
			$this->form_validation->set_rules('vehiculo_autorizacion_id','Persona Autorizada','required');
			$this->form_validation->set_rules('descripcion','Descripci&oacute;n','required');
			$this->form_validation->set_rules('fecha_desde','Fecha Desde','required');

			if($this->form_validation->run())
            {

                $params = array(
            	'vehiculo_id' => $this->input->post('vehiculo_id'),
				'vehiculo_autorizacion_id' => $this->input->post('vehiculo_autorizacion_id'),
				'descripcion' => $this->input->post('descripcion'),
				'fecha_desde' => $this->input->post('fecha_desde'),
				'modified'=> date('Y-m-d H:i:s'),
              );

                $this->model->update_vehiculo_calendario($id,$params);
                redirect('vehiculos_calendario/index');
            }
            else
            {
				$this->load->model('Vehiculo_autorizacion_model');
				$data['all_autorizaciones'] = $this->Vehiculo_autorizacion_model->get_all_personas();

				$this->load->model('Vehiculo_model');
				$data['all_vehiculos'] = $this->Vehiculo_model->get_all_vehiculos_select();

                $data['_view'] = 'vehiculo_calendario/edit';
                $this->load->view('layouts/main',$data);
            }
        }
        else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos_calendario/index');
        }
    }

    /*
     * Deleting notas_calefon
     */
    function remove($id)
    {
        if (!$this->ion_auth->in_group('vehiculos'))
      	{
       		redirect('/', 'refresh');
      	}
        $vehiculo = $this->model->get_vehiculo_calendario($id);

        // check if the notas_calefon exists before trying to delete it
        if(isset($vehiculo['id']))
        {
            $params = array('isDelete'=>1,'deleteFecha'=>date('Y-m-d H:i:s'));
            $vehiculo = $this->model->update_vehiculo_calendario($id, $params);
            redirect('vehiculos_calendario/index');
        }
         else
        {
            $this->session->set_flashdata('error', 'Lo que est&aacute;s intentando eliminar no existe o no tienes los permisos para su acceso.');
            redirect('vehiculos_calendario/index');
        }
    }

}
