<?php

class Calefon_resumen_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

     function get_estados($proyecto = 0)
    {
       $query = $this->db->query('Select
       								e.id,
								    e.estado_nombre,
								    e.color_hex
								From
								    estados As e
								Where
								    e.proyecto_id = 1
								Order by e.orden');


	   return $query->result_array();
    }

    function get_prueba1($proyecto = 0)
    {
       $query = $this->db->query('Select
								    p.nom_ape,
								    count(*) as cantidad
								From
								    calefones_inscripciones as c Inner Join
								    personas as p On p.id = c.persona_id
								group by c.persona_id');

        return $query->result_array();
    }

    function get_cant_inscriptos_localidades_estados_array($estados)
    {
        $consulta = 'Select p.nom_ape';
        foreach($estados as $e)
        {
			$consulta .= ', Sum(Case When c.estado_id = '.$e['id'].' Then 1 Else 0 End) As ' . str_replace(" ","_",$e['estado_nombre']);
        }


        $consulta .= ' From
						    calefones_inscripciones As c Left Join
						    personas As p On p.id = c.persona_id
						Group By
						    p.id';

	   //echo $consulta;
        $query = $this->db->query($consulta);
        return $query->result_array();
       //return;
    }



     function get_cant_inscriptos_localidades_estados($proyecto = 0)
    {
       $query = $this->db->query('Select
								    l.localidad,
								    count(*) As cantidad,
								    e.estado_nombre,
								    e.color_hex
								From
								    calefones_inscripciones As c Join
								    estados As e On e.id = c.estado_id Join
								    localidades As l On l.id = c.localidad_id
								Where
								    e.proyecto_id = 1
								Group By
								    e.estado_nombre,
								    l.id
								Order by l.localidad');


	   return $query->result_array();
    }
       /*
     * Get proyecto
     */
    function get_cant_calefones_estados()
    {
          $query = $this->db->query('Select
						    l.localidad,
						    count(l.id) as total,
						    Sum(Case
						        When c.estado_id = 1
						        Then 1
						        Else 0
						    End) As sinasignar,
						    Sum(Case
						        When c.estado_id = 2
						        Then 1
						        Else 0
						    End) As verificacion,
						    Sum(Case
						        When c.estado_id = 3
						        Then 1
						        Else 0
						    End) As rechazados,
						    Sum(Case
						        When c.estado_id = 4
						        Then 1
						        Else 0
						    End) As aprobados,
						    Sum(Case
						        When c.estado_id = 5
						        Then 1
						        Else 0
						    End) As factibilidad,
						    Sum(Case
						        When c.estado_id = 6
						        Then 1
						        Else 0
						    End) As informe_evaluador,
						    Sum(Case
						        When c.estado_id = 7
						        Then 1
						        Else 0
						    End) As inicio_expediente
						From
						    calefones_inscripciones As c Left Join
						    localidades as l  On l.id = c.localidad_id
						Group By
						    l.id
						Order By l.localidad');
        return $query->result_array();
    }


     /*
     * Mostrar Todas Las inscripciones y segun su estado
      DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
     */
    function get_all_inscripciones($estado = 0)
    {
    	 $this->db->select('c.id,
						    fecha,
						    c.email,
						    c.ape_nom,
						    c.dni,
						    c.estado_civil,
						    c.fecha_titular_vivienda,
						    c.grupo_familiar,
						    c.telefono,
						    c.domicilio,
						    c.localidad,
						    c.registro_propiedad,
						    c.zona_vivienda,
						    c.servicios_publicos_zona,
						    c.material_vivienda,
						    c.fuente_ingresos,
						    c.ingresos_familiar,
						    c.nom_ape_garante,
						    c.dni_garante,
						    c.estado_civil_garante,
						    c.domicilio_garante,
						    c.localidad_garante,
						    c.lugar_trabajo_garante,
						    c.ingresos_garante,
						    c.estado_id,
						    c.evaluador_asignado,
						    c.persona_id,
						    e.estado_nombre,
						    e.color
          					');
        $this->db->from('calefones_inscripciones as c');
        $this->db->join('estados as e','e.id = c.estado_id');

         if ($estado > 0)
        {
        	 $this->db->where('c.estado_id',  $estado);
        }
        $this->db->order_by('c.id', 'asc');
        return $this->db->get()->result_array();
    }

    function get_cant_estados($proyecto = 0)
    {
        $this->db->select(' e.id,
        					e.estado_nombre,
						    e.color,
						    e.icono,
						    count(*) as cantidad
          					');
        $this->db->from('calefones_inscripciones as c');
        $this->db->join('estados as e','e.id = c.estado_id');

        $this->db->where('e.proyecto_id', 1);

        $this->db->group_by('e.id');
        $this->db->order_by('e.orden', 'asc');
        return $this->db->get()->result_array();

    }

     function get_cant_evaluadores_estados($proyecto = 0)
    {
        $this->db->select(' p.nom_ape,
						    count(*) as cantidad
          					');
        $this->db->from('calefones_inscripciones as c');
        $this->db->join('estados as e','e.id = c.estado_id');
        $this->db->join('personas as p','p.id = c.persona_id');
        $this->db->where('e.proyecto_id', 1);
        $this->db->group_by('p.id');


        return $this->db->get()->result_array();

    }

      /*
     * Get all inscripciones
      DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
     */
    function get_administrar_inscripciones()
    {
    	 $this->db->select('c.id,
						    fecha,
						    c.email,
						    c.ape_nom,
						    c.dni,
						    c.estado_civil,
						    c.fecha_titular_vivienda,
						    c.grupo_familiar,
						    c.telefono,
						    c.domicilio,
						    c.localidad,
						    c.registro_propiedad,
						    c.zona_vivienda,
						    c.servicios_publicos_zona,
						    c.material_vivienda,
						    c.fuente_ingresos,
						    c.ingresos_familiar,
						    c.nom_ape_garante,
						    c.dni_garante,
						    c.estado_civil_garante,
						    c.domicilio_garante,
						    c.localidad_garante,
						    c.lugar_trabajo_garante,
						    c.ingresos_garante,
						    c.estado_id,
						    c.evaluador_asignado,
						    c.persona_id,
						    e.estado_nombre,
						    e.color
          					');
        $this->db->from('calefones_inscripciones as c');
        $this->db->join('estados as e','e.id = c.estado_id');
        $this->db->order_by('c.id', 'asc');
        return $this->db->get()->result_array();
    }

}
