<?php
class DTarea_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

      /*
     * Get proyecto
     */
    function get_cant_tareas_areas_estados()
    {
        $this->db->select(' a.nomcorto,
						       SUM(CASE WHEN t.estado = 1 THEN 1 ELSE 0 END) AS ejecucion,
						       SUM(CASE WHEN t.estado = 2 THEN 1 ELSE 0 END) AS finalizados
						   ');
        $this->db->from('tareas as t');
        $this->db->join('areas as a','a.areaId = t.areaId');
        $this->db->where('t.isDelete', 0);
        $this->db->group_by('t.areaId');
        $this->db->order_by('t.areaId', 'asc');
        return $this->db->get()->result_array();
    }
     /*
     * Get all tareas
     */
    function get_all_tareas($estado = 0)
    {
    	 $this->db->select('
          					t.id,
          					t.tarea,
						    t.detalle,
						    t.prioridadId,
						    t.areaId,
						    t.estado,
						    t.avance,
						    t.enviarCorreo,
						    DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
						    Prioridad.prioridad,
						    Areas.area,
						    r.nombre');
        $this->db->from('tareas as t');
        $this->db->join('prioridades as Prioridad','Prioridad.prioridadId = t.prioridadId');
        $this->db->join('areas as Areas','Areas.areaId = t.areaId');
        $this->db->join('responsabledeproyectos as r','r.id = t.responsableId', 'left');
        $this->db->where('t.isDelete', 0);
         if ($estado > 0)
        {
        	 $this->db->where('t.estado',  $estado);
        }
        $this->db->order_by('id', 'desc');
        return $this->db->get()->result_array();
    }
      /*
     * Get Todos las Tareas en Ejecucin cuya fecha de finalizacion estn programada en la semana
     */
    function get_tareas_ejecucion_semanal($fechaini, $fechafin)
    {
         $this->db->select('
          					t.id,
          					t.tarea,
						    t.detalle,
						    t.prioridadId,
						    t.avance,
						    DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
						    Prioridad.prioridad,
						    Areas.area,
						    r.nombre');
        $this->db->from('tareas as t');
        $this->db->join('prioridades as Prioridad','Prioridad.prioridadId = t.prioridadId');
        $this->db->join('areas as Areas','Areas.areaId = t.areaId');
        $this->db->join('responsabledeproyectos as r','r.id = t.responsableId', 'left');
        $this->db->where(array(
        					't.fecha >=' => $fechaini,
        					't.fecha <=' => $fechafin,
        					't.isDelete'=> 0,
                            't.estado'=> 1
        			));
       // $this->db->group_by('proyectos.id');
        $this->db->order_by('t.areaId');
       $tareas = $this->db->get()->result_array();
      /* $data = array();
       foreach($proyectos as $p){

         $data[$p['id']]['proyecto'] = $p['title'];
         $data[$p['id']]['pid'] = $p['id'];
         $data[$p['id']]['area'] = $p['area'];
         $data[$p['id']]['prioridadId'] = $p['prioridadId'];
         $data[$p['id']]['actividades'][] = array('anombre' => $p['enombre'], 'fechaini' => $p['fechaini'],'fechafin' => $p['fechafin']);
       } */
       return $tareas;
    }

}
