<?php
class Microbanco_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }


    function get_cant_convocatorias($proyecto = 0)
    {
        $this->db->select(' c.id,
        					c.convocatoria,
						    c.color,
						    c.icono,
						    c.color_hex,
						    count(m.id) as cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->group_by('m.convocatoria_id');
        $this->db->order_by('c.orden', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones($convocatoria = 0, $estado = 0,  $localidad = 0)
    {
    	 $this->db->select('m.id,
    	 					m.ape_nom,
    	 					e.estado_nombre,
    	 					e.color as estado_color,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
                            c.convocatoria,
                            c.color,
                            l.localidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
         $this->db->join('m_estados as e','e.id = m.m_estado_id');
         if ($convocatoria > 0) {
     	 $this->db->where('m.convocatoria_id',  $convocatoria);
        }

        if ($estado > 0) {
     	 $this->db->where('m.m_estado_id',  $estado);
        }

         if ($localidad > 0) {
     	 $this->db->where('m.localidad_id',  $localidad);
        }

        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones_localidades($convocatoria = 0, $persona = 0)
    {
    	 $this->db->select('m.id,
    	 					l.localidad,
    	 					c.convocatoria,
    	 					c.color_hex,
    	 					count(*) As cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        //  $this->db->join('personas as p','p.id = c.persona_id', 'left');

     	$this->db->where('m.convocatoria_id',  $convocatoria);
     	$this->db->group_by('l.id');


        /* if ($persona > 0) {
     	 $this->db->where('c.persona_id',  $persona);
        }  */
        $this->db->order_by('l.localidad', 'asc');
        return $this->db->get()->result_array();
    }

       function get_all_inscripciones_estados($convocatoria = 0, $persona = 0)
    {
    	 $this->db->select('m.id,
    	 					m.convocatoria_id,
    	 					e.estado_nombre,
    	 					c.convocatoria,
    	 					e.id as estadoid,
    	 					e.color,
    	 					e.icono,
    	 					e.color_hex,
    	 					count(*) As cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
     	$this->db->where('m.convocatoria_id',  $convocatoria);
     	$this->db->group_by('e.id');
        $this->db->order_by('e.orden', 'asc');
        return $this->db->get()->result_array();
    }

    function get_all_inscripciones_convocatoria_estado($convocatoria = 0, $estado = 0)
    {
    	 $this->db->select('m.id,
    	 					m.ape_nom,
    	 					e.estado_nombre,
    	 					e.color as estado_color,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
                            c.convocatoria,
                            c.color,
                            l.localidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
         if ($convocatoria > 0) {
     	 $this->db->where('m.convocatoria_id',  $convocatoria);
        }
         if ($estado > 0) {
     	 $this->db->where('m.m_estado_id',  $estado);
        }
        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }


    function get_inscripcion($inscripcion_id = 0)
    {
    	 $this->db->select('m.id,
    	 					m.situacion,
    	 					m.convocatoria_id,
						    c.convocatoria,
						    m.localidad,
						    m.ape_nom,
    	 					m.dni,
						    m.tel,
						    m.email,
						    m.sector,
						    m.nueva_en_marcha,
						    m.inversion_a_solicitar,
						    m.fecha_capacitacion,
						    m.asistencia,
						    m.asesor_asignado,
						    c.color
          					');

        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->where('m.id',  $inscripcion_id);

        return $this->db->get()->row_array();
    }



      /*
     * Get all inscripciones
      DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
     */
    function get_administrar_inscripciones()
    {
    	 $this->db->select('c.id,
						    fecha,
						    c.email,
						    c.ape_nom,
						    c.dni,
						    c.estado_civil,
						    c.fecha_titular_vivienda,
						    c.grupo_familiar,
						    c.telefono,
						    c.domicilio,
						    c.localidad,
						    c.registro_propiedad,
						    c.zona_vivienda,
						    c.servicios_publicos_zona,
						    c.material_vivienda,
						    c.fuente_ingresos,
						    c.ingresos_familiar,
						    c.nom_ape_garante,
						    c.dni_garante,
						    c.estado_civil_garante,
						    c.domicilio_garante,
						    c.localidad_garante,
						    c.lugar_trabajo_garante,
						    c.ingresos_garante,
						    c.estado_id,
						    c.evaluador_asignado,
						    c.persona_id,
						    e.estado_nombre,
						    e.color
          					');
        $this->db->from('calefones_inscripciones as c');
        $this->db->join('estados as e','e.id = c.estado_id');

        $this->db->order_by('c.id', 'asc');
        return $this->db->get()->result_array();
    }



      function get_all_inscipcion_historial_estados($id)
    {

        $this->db->select('h.id,
        					e.estado_nombre,
    						DATE_FORMAT(h.fecha, "%d/%m/%Y") as fecha,
    						h.observaciones
          					');
        $this->db->from('estados as e');
        $this->db->join('asignacion_estados as h','e.id = h.estado_id');
        $this->db->where('h.inscripcion_id', $id);
         $this->db->order_by('h.id', 'desc');
        return $this->db->get()->result_array();
    }

    function get_movimientos($id)
    {

        $this->db->select('m.id,
						    m.expediente_id,
						    DATE_FORMAT(m.fecha, "%d/%m/%Y") as fecha,
						    m.expediente_title,
						    m.area_title,
						    m.aefectos,
						    DATE_FORMAT(m.fechadev, "%d/%m/%Y") as fechadev,
						    m.numemovi
          					');
        $this->db->from('movimientos as m');
        $this->db->where('m.expediente_id', $id);
         $this->db->order_by('m.numemovi', 'desc');
        return $this->db->get()->result_array();
    }

      function get_alertas()
    {
         $this->db->select('a.id,
         					m.ape_nom,
         					a.inscripcion_id,
						    a.fecha_alerta,
						    a.nota,
						    a.detalle,
						    a.activo
          					');
        $this->db->from('microbanco_alertas as a');
        $this->db->join('microbanco_datos as m','m.id = a.inscripcion_id');
        $this->db->where('a.isDelete', 0);
        $this->db->where('a.activo', 1);

        $this->db->order_by('a.fecha_alerta', 'desc');
        return $this->db->get()->result_array();
    }



}
