<?php
class Microbanco_resumen_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

    function get_cant_inscrip_xasesor()
    {
        $this->db->select('a.nom_ape,
    					   count(m.id) as cantidad
          					');
        $this->db->from('m_asesor as a');
        $this->db->join('microbanco_datos as m','a.id = m.asesor_id');
        $this->db->group_by('m.asesor_id');
        $this->db->order_by('a.nom_ape', 'asc');
        return $this->db->get()->result_array();
    }

     function get_cant_inscrip_xavaluador()
    {
        $this->db->select('e.nom_ape,
    					   count(m.id) as cantidad
          					');
        $this->db->from('m_evaluador as e');
        $this->db->join('microbanco_datos as m','e.id = m.evaluador_id');
        $this->db->group_by('m.evaluador_id');
        $this->db->order_by('e.nom_ape', 'asc');
        return $this->db->get()->result_array();
    }

      function get_cant_inscrip_xsituacion()
    {
        $this->db->select('e.id,
        				   e.estado_nombre,
        				   e.color_hex,
    					   count(m.id) as cantidad
          					');
        $this->db->from('m_estados as e');
        $this->db->join('microbanco_datos as m','e.id = m.m_estado_id');
        $this->db->group_by('m.m_estado_id');
        $this->db->order_by('e.orden', 'asc');
        return $this->db->get()->result_array();
    }

    function get_cant_inscrip_xsituacion_general()
    {

    	$query = $this->db->query('Select
			    g.nombre as estado_nombre,
			    e.color_hex,
			    count(m.id) as cantidad
			From
			    m_estados e Inner Join
			    microbanco_datos as m On e.id = m.m_estado_id Inner Join
			    m_estados_general g  On g.id = e.m_estados_general_id
			group by  g.id
			order by g.orden');

		return $query->result_array();

	}

      function get_cant_inscrip_xlocalidad()
    {
        $this->db->select('l.localidad,
    					   count(m.id) as cantidad
          					');
        $this->db->from('localidades as l');
        $this->db->join('microbanco_datos as m','l.id = m.localidad_id');
        $this->db->group_by('m.localidad_id');
        $this->db->order_by('l.localidad', 'asc');
        return $this->db->get()->result_array();
    }

    function get_cant_inscrip_xdepartamento()
    	{
          $query = $this->db->query('Select
				    d.nombre as localidad,
				    Count(m.id) As cantidad
				From
				    localidades As l Inner Join
				    microbanco_datos As m On l.id = m.localidad_id Inner Join
				    departamentos as d On l.departamento_id = d.id
				Group By
				    d.id
				order by d.nombre');
		return $query->result_array();
    }

    function localicad_cant_otorgado()
    {
         $query = $this->db->query('Select
							    l.localidad,
							    sum(c.monto_otorgamiento) as total_monto_otorgado,
							    count(c.id) as cantidad_creditos,
							    Sum(Case
						        When e.id = 4 AND YEAR(c.fecha_otorgamiento) = 2020
						        Then 1
						        Else 0
						    		End) As otorgada2020,
						    		 Sum(Case
						        When e.id = 4 AND  YEAR(c.fecha_otorgamiento) = 2021
						        Then 1
						        Else 0
						    		End) As otorgada2021,
						    		 Sum(Case
						        When e.id = 4 AND YEAR(c.fecha_otorgamiento) = 2022
						        Then 1
						        Else 0
						    		End) As otorgada2022,
						    		 Sum(Case
						        When e.id = 23 AND YEAR(c.fecha_otorgamiento) = 2020
						        Then 1
						        Else 0
						    		End) As desistio2020,
						    		 Sum(Case
						        When e.id = 23 AND  YEAR(c.fecha_otorgamiento) = 2021
						        Then 1
						        Else 0
						    		End) As desistio2021,
						    		 Sum(Case
						        When e.id = 23 AND YEAR(c.fecha_otorgamiento) = 2022
						        Then 1
						        Else 0
						    		End) As desistio2022
							From
							    microbanco_creditos as c Inner Join
							    microbanco_datos as d On c.microbanco_dato_id = d.id Inner Join
							    localidades as l On l.id = d.localidad_id Inner Join
    							m_estados  AS e On e.id = d.m_estado_id
							Group By
							    l.id
							ORDER BY l.localidad
        					');
		return $query->result_array();
    }

    function localicad_monto_otorgado()
    {
      $query = $this->db->query('Select
							    l.localidad,
							    sum(c.monto_otorgamiento) as total_monto_otorgado,
							    count(c.id) as cantidad_creditos
							From
							    microbanco_creditos as c Inner Join
							    microbanco_datos as d On c.microbanco_dato_id = d.id Inner Join
							    localidades as l On l.id = d.localidad_id
							Group By
							    l.id
							ORDER BY l.localidad
        					');
		return $query->result_array();
    }

    function get_resumen_pagos()
    {
        $this->db->select('sum(c.monto_otorgamiento) as monto_otorgamiento,
        				   sum(c.total_credito) as total_credito,
          					');
        $this->db->from('microbanco_creditos as c');
        return $this->db->get()->result_array();
    }

     function get_total_depositado()
    {
        $this->db->select('sum(c.monto_depositado) as monto_depositado
          					');
        $this->db->from('microbanco_credito_cuotas as c');
        return $this->db->get()->result_array();
    }

     function get_monto_exigible_depositado($date)
       {
        $this->db->select('sum(c.monto_cuota) as monto_exigible,
							sum(c.monto_depositado) as monto_depositado
          					');
        $this->db->from('microbanco_credito_cuotas as c');
        $this->db->where('c.fecha_vencimiento <=',  $date);

        return $this->db->get()->row_array();
    }

     function get_cant_creditos()
    {
        $this->db->select('count(*) as cantidad_creditos,
          					');
        $this->db->from('microbanco_creditos as c');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones($convocatoria = 0, $persona = 0)
    {
    	 $this->db->select('m.id,
    	 					m.ape_nom,
    	 					e.estado_nombre,
    	 					e.color as estado_color,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
                            c.convocatoria,
                            c.color,
                            l.localidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
         $this->db->join('m_estados as e','e.id = m.m_estado_id');
         if ($convocatoria > 0) {
     	 $this->db->where('m.convocatoria_id',  $convocatoria);
        }
        /* if ($persona > 0) {
     	 $this->db->where('c.persona_id',  $persona);
        }  */
        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones_localidades($convocatoria = 0, $persona = 0)
    {
    	 $this->db->select('m.id,
    	 					l.localidad,
    	 					c.convocatoria,
    	 					c.color_hex,
    	 					count(*) As cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        //  $this->db->join('personas as p','p.id = c.persona_id', 'left');

     	$this->db->where('m.convocatoria_id',  $convocatoria);
     	$this->db->group_by('l.id');


        /* if ($persona > 0) {
     	 $this->db->where('c.persona_id',  $persona);
        }  */
        $this->db->order_by('l.localidad', 'asc');
        return $this->db->get()->result_array();
    }

       function get_all_inscripciones_estados($convocatoria = 0, $persona = 0)
    {
    	 $this->db->select('m.id,
    	 					m.convocatoria_id,
    	 					e.estado_nombre,
    	 					c.convocatoria,
    	 					e.id as estadoid,
    	 					e.color,
    	 					e.icono,
    	 					e.color_hex,
    	 					count(*) As cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
     	$this->db->where('m.convocatoria_id',  $convocatoria);
     	$this->db->group_by('e.id');
        $this->db->order_by('e.orden', 'asc');
        return $this->db->get()->result_array();
    }

    function get_all_inscripciones_convocatoria_estado($convocatoria = 0, $estado = 0)
    {
    	 $this->db->select('m.id,
    	 					m.ape_nom,
    	 					e.estado_nombre,
    	 					e.color as estado_color,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
                            c.convocatoria,
                            c.color,
                            l.localidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
         if ($convocatoria > 0) {
     	 $this->db->where('m.convocatoria_id',  $convocatoria);
        }
         if ($estado > 0) {
     	 $this->db->where('m.m_estado_id',  $estado);
        }
        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }


    function get_inscripcion($inscripcion_id = 0)
    {
    	 $this->db->select('m.id,
    	 					m.situacion,
    	 					m.convocatoria_id,
						    c.convocatoria,
						    m.localidad,
						    m.ape_nom,
    	 					m.dni,
						    m.tel,
						    m.email,
						    m.sector,
						    m.nueva_en_marcha,
						    m.inversion_a_solicitar,
						    m.fecha_capacitacion,
						    m.asistencia,
						    m.asesor_asignado,
						    c.color
          					');

        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->where('m.id',  $inscripcion_id);

        return $this->db->get()->row_array();
    }

     function get_asesor_estados()
    {

     $query = $this->db->query('Select
								    e.estado_nombre,
								    Sum(Case
												  When d.asesor_id = 0
														  Then 1
														  Else 0
												End) As sin_asesor,
								    Sum(Case
												  When d.asesor_id = 1
														  Then 1
														  Else 0
												End) As javier,
								    Sum(Case
												  When d.asesor_id = 2
														  Then 1
														  Else 0
												End) As noelia,
								    Sum(Case
												  When d.asesor_id = 3
														  Then 1
														  Else 0
												End) As martin,
								    Sum(Case
												  When d.asesor_id = 4
														  Then 1
														  Else 0
												End) As emanuel,
								    Sum(Case
												  When d.asesor_id = 5
														  Then 1
														  Else 0
												End) As carlos,
								    Sum(Case
												  When d.asesor_id = 6
														  Then 1
														  Else 0
												End) As rosana,
								    Sum(Case
												  When d.asesor_id = 7
														  Then 1
														  Else 0
												End) As rosa
								From
								    microbanco_datos d right join m_estados e On e.id = d.m_estado_id
								Group By
								    e.estado_nombre
								Order by e.orden
          					');

         return $query->result_array();
 	}

 	 function get_asesor_estados_general()
    {

     $query = $this->db->query('Select
                                    g.nombre as estado_nombre,
								    Sum(Case
								        When d.asesor_id = 0
								        Then 1
								        Else 0
								    End) As sin_asesor,
								    Sum(Case
								        When d.asesor_id = 1
								        Then 1
								        Else 0
								    End) As javier,
								    Sum(Case
								        When d.asesor_id = 2
								        Then 1
								        Else 0
								    End) As noelia,
								    Sum(Case
								        When d.asesor_id = 3
								        Then 1
								        Else 0
								    End) As martin,
								    Sum(Case
								        When d.asesor_id = 4
								        Then 1
								        Else 0
								    End) As emanuel,
								    Sum(Case
								        When d.asesor_id = 5
								        Then 1
								        Else 0
								    End) As carlos,
								    Sum(Case
								        When d.asesor_id = 6
								        Then 1
								        Else 0
								    End) As rosana,
								    Sum(Case
								        When d.asesor_id = 7
								        Then 1
								        Else 0
								    End) As rosa
								From
								    microbanco_datos d Right Join
								    m_estados e On e.id = d.m_estado_id Inner Join
								    m_estados_general as g On g.id = e.m_estados_general_id
								Group By
								    g.nombre
								Order By
								    g.orden
          					');

         return $query->result_array();
 	}

    function get_creditos_morosos($date)

    {

      $query = $this->db->query('Select

								    c.id,

								    c.expediente_nro,

								    d.ape_nom,

									l.localidad,

									c.actividad,

									DATE_FORMAT(c.fecha_otorgamiento, "%d/%m/%Y") as fecha_otorgamiento,

									c.monto_otorgamiento,

									c.total_credito,

								    count(cuo.microbanco_credito_id) as cuotas_morosas

								From

								   microbanco_creditos as c Inner Join

									 microbanco_datos as d On c.microbanco_dato_id = d.id Inner Join

									localidades as l On l.id = d.localidad_id left Join

									microbanco_credito_cuotas as cuo On cuo.microbanco_credito_id = c.id

								Where

								    cuo.fecha_vencimiento <= "'.$date.'" And

								    cuo.monto_depositado <= 0

								group by cuo.microbanco_credito_id

								order by cuotas_morosas desc

        					');

		return $query->result_array();

    }


      function get_creditos_resumen_pagos($date)
    {

      $query = $this->db->query('Select c.id,
      							c.expediente_nro,
      							d.ape_nom,
      							l.localidad,
      							c.actividad,
								DATE_FORMAT(c.fecha_otorgamiento, "%d/%m/%Y") as fecha_otorgamiento,
								c.monto_otorgamiento,
								c.total_credito,
								sum(cuo.monto_cuota) as t_cuotas_a_date,
								sum(cuo.monto_depositado) as total_depositado,
								sum(IF( cuo.fecha_pago != "00/00/0000" , 0, 1 )) as cant_cuotas_impagas,
								sum(IF( cuo.fecha_pago != "00/00/0000" , cuo.mora, (cuo.monto_cuota * TIMESTAMPDIFF(DAY, cuo.fecha_vencimiento, NOW()) * 0.0015) )) as mora

								From microbanco_creditos as c Inner Join microbanco_datos as d On c.microbanco_dato_id = d.id
								Inner Join localidades as l On l.id = d.localidad_id
								left Join microbanco_credito_cuotas as cuo On cuo.microbanco_credito_id = c.id
								WHERE cuo.fecha_vencimiento <= "2024-10-21" and c.finalizado != 1 group by cuo.microbanco_credito_id order by cant_cuotas_impagas desc;
								        					');



		return $query->result_array();

    }




    function get_monto_por_anio()
    {
      $query = $this->db->query('SELECT YEAR(fecha_vencimiento) as anioVen, sum(monto_cuota) AS TotalVen, YEAR(fecha_pago) AS anioPago, sum(monto_depositado) AS totalDepositado
								 FROM microbanco_credito_cuotas GROUP BY anioVen
        					');
		return $query->result_array();
    }

     function get_monto_hasta_actual_por_anio($date)
    {
      $query = $this->db->query('SELECT YEAR(fecha_vencimiento) as anioVen, sum(monto_cuota) AS TotalVen, YEAR(fecha_pago) AS anioPago, sum(monto_depositado) AS totalDepositado
								 FROM microbanco_credito_cuotas where fecha_vencimiento <= "'.$date.'" GROUP BY anioVen
        					');
		return $query->result_array();
    }

}
