<?php
class Microbancoxanio_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

     /*
     * Mostrar Todas Las inscripciones y segun su estado
      DATE_FORMAT(t.fecha, "%d/%m/%Y") as fecha,
     */
    function get_all_inscripciones($anio=0)
    {

    	  $this->db->select('m.id,
         					m.m_estado_id,
    	 					m.ape_nom,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
    	 					m.asesor_id,
    	 					m.evaluador_id,
                            c.convocatoria,
                            c.color,
                            l.localidad,
                            e.estado_nombre,
                            e.color as estadocolor,
                            ase.nom_ape as asesor,
                            eva.nom_ape as evaluador
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
        $this->db->join('m_asesor as ase', 'ase.id = m.asesor_id', 'left');
        $this->db->join('m_evaluador as eva', 'eva.id = m.evaluador_id', 'left');

  		$this->db->where('m.anio',  $anio);
        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones_x_estados($estado=0, $anio=0)
    {

    	  $this->db->select('m.id,
         					m.m_estado_id,
    	 					m.ape_nom,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
    	 					m.asesor_id,
    	 					m.evaluador_id,
                            c.convocatoria,
                            c.color,
                            l.localidad,
                            e.estado_nombre,
                            e.color as estadocolor,
                            ase.nom_ape as asesor,
                            eva.nom_ape as evaluador
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
        $this->db->join('m_asesor as ase', 'ase.id = m.asesor_id', 'left');
        $this->db->join('m_evaluador as eva', 'eva.id = m.evaluador_id', 'left');
  		$this->db->where('m.anio',  $anio);
        $this->db->where('m.m_estado_id', $estado);

        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscripciones_estado($estado = 0)
    {
    	//echo $estado;
         $this->db->select('m.id,
    	 					m.ape_nom,
    	 					e.estado_nombre,
    	 					e.color as estado_color,
    	 					m.tel,
    	 					m.email,
    	 					m.dni,
                            c.convocatoria,
                            c.color,
                            l.localidad,
                            ase.nom_ape as asesor,
                            eva.nom_ape as evaluador
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
        $this->db->join('m_asesor as ase', 'ase.id = m.asesor_id', 'left');
        $this->db->join('m_evaluador as eva', 'eva.id = m.evaluador_id', 'left');
     	$this->db->where('m.m_estado_id',  $estado);
        $this->db->order_by('m.id', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_inscipcion_historial_estados($id)
    {

        $this->db->select('h.id,
        					e.estado_nombre,
    						DATE_FORMAT(h.fecha, "%d/%m/%Y") as fecha,
    						h.observaciones
          					');
        $this->db->from('m_estados as e');
        $this->db->join('microbanco_historial_estados as h','e.id = h.m_estado_id');
        $this->db->where('h.inscripcion_id', $id);
         $this->db->order_by('h.id', 'desc');
        return $this->db->get()->result_array();
    }

        function get_inscripcion($inscripcion_id = 0)
    {
    	 $this->db->select('m.id,
    	 					m.situacion,
    	 					m.convocatoria_id,
						    c.convocatoria,
						    m.localidad_id,
						    m.localidad,
						    m.m_estado_id,
						    m.ape_nom,
    	 					m.dni,
						    m.tel,
						    m.email,
						    m.sector,
						    m.nueva_en_marcha,
						    m.inversion_a_solicitar,
						    m.fecha_capacitacion,
						    m.asistencia,
						    m.asesor_asignado,
    	 					m.asesor_id,
    	 					m.evaluador_id,
						    c.color,
						    l.localidad,
						    e.estado_nombre,
                            e.color as estadocolor
          					');

        $this->db->from('microbanco_datos as m');
        $this->db->join('convocatorias as c','c.id = m.convocatoria_id');
        $this->db->join('localidades as l','l.id = m.localidad_id');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
        $this->db->where('m.id',  $inscripcion_id);

        return $this->db->get()->row_array();
    }




    function get_all_count_inscripcion_estados($anio=0)
    {
          $this->db->select('m.id,
    	 					m.convocatoria_id,
    	 					e.estado_nombre,
    	 					e.id as estadoid,
    	 					e.color,
    	 					e.icono,
    	 					e.color_hex,
    	 					count(*) As cantidad
          					');
        $this->db->from('microbanco_datos as m');
        $this->db->join('m_estados as e','e.id = m.m_estado_id');
        $this->db->where('m.anio',  $anio);
     	$this->db->group_by('e.id');
        $this->db->order_by('e.orden', 'asc');
        return $this->db->get()->result_array();
    }

     function get_alertas($id = 0)
    {
         $this->db->select('a.id,
						    a.fecha_alerta,
						    a.inscripcion_id,
						    a.nota,
						    a.detalle,
						    a.activo
          					');
        $this->db->from('microbanco_alertas as a');
         $this->db->where('a.inscripcion_id', $id);
        $this->db->where('a.isDelete', 0);

        $this->db->order_by('a.fecha_alerta', 'desc');
        return $this->db->get()->result_array();
    }



}
