<?php
/*
 * Generated by CRUDigniter v3.2
 * www.crudigniter.com
 */

class User_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

    /*
     * Get user by id
     */
    function get_user($id)
    {
         $this->db->select('u.id,
							u.first_name,
							u.last_name,
							u.company,
							u.phone,
							u.ip_address,
							u.username,
							u.email,
							u.active
          					');
         $this->db->from('users as u');
         $this->db->where('u.id', $id);
        return $this->db->get()->row_array();
    }

    /*
     * Get all users
     */
    function get_all_users()
    {
        $this->db->select('u.id,
							u.first_name,
							u.last_name,
							u.company,
							u.phone,
							u.ip_address,
							u.username,
							u.email,
							u.active
          					');
        $this->db->from('users as u');
        $this->db->order_by('id', 'desc');
        return $this->db->get()->result_array();
    }

    /*
     * function to add new user
     */
    function add_user($params)
    {
        $this->db->insert('users',$params);
        return $this->db->insert_id();
    }

    /*
     * function to update user
     */
    function update_user($id,$params)
    {
        $this->db->where('id',$id);
        return $this->db->update('users',$params);
    }

    /*
     * function to delete user
     */
    function delete_user($id)
    {
        return $this->db->delete('users',array('id'=>$id));
    }

     function get_max_user_id()
    {
         $this->db->select('MAX(id) as max_id
          					');
         $this->db->from('users as u');
         $id_array = $this->db->get()->row_array();

         if (sizeof($id_array) > 0){
            return	$id_array['max_id'] ;
         }

         return -1;

    }

    /*
     * Get all groups
     */
    function get_all_groups()
    {
        $this->db->order_by('id', 'desc');
        return $this->db->get('groups')->result_array();
    }

     /*
     * Get User Groups
     */
    function get_users_groups($id)
    {

         $this->db->select('*
          					');
         $this->db->from('users_groups as gu');
         $this->db->join('groups as g','gu.group_id = g.id');
         $this->db->where('gu.user_id', $id);
        return $this->db->get()->result_array();
    }

     function add_user_group($params, $id)
    {
         $this->db->trans_begin();

         $this->db->delete('users_groups',array('user_id'=>$id));

         $data = array();
         foreach ($params as $clave => $grp)
		 {

			  $data[$clave] = array(
	                'user_id' => $id,
	                'group_id' => $grp
				);
		 }

		$this->db->insert_batch('users_groups', $data);

		if ($this->db->trans_status() === FALSE)
		{
		   $this->db->trans_rollback();
		}
		else
		{
		  $this->db->trans_commit();
		}

       return;
    }



}
