<?php

class Vehiculo_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

     /*
     * Get all vehiculo
     */
    function get_all_vehiculos()
    {
        $this->db->select('*');
        $this->db->from('vehiculos as v');
        $this->db->where('v.isDelete', 0);
        $this->db->order_by('v.id', 'desc');
        return $this->db->get()->result_array();
    }

      function get_all_vehiculos_select()
    {
        $this->db->select('concat(v.patente, " ** ", v.marca, " ** " , v.modelo) as nombre, id');
        $this->db->from('vehiculos as v');
        $this->db->where('v.isDelete', 0);
        $this->db->order_by('v.patente', 'asc');
        return $this->db->get()->result_array();
    }

      /*
     * Get notas_Vehiculo
     */
    function get_vehiculo($id)
    {
        return $this->db->get_where('vehiculos',array('id'=>$id))->row_array();
    }

    /*
     * function Nuevo Vehiculo
     */
    function add_vehiculo($params)
    {
        $this->db->insert('vehiculos',$params);
        return $this->db->insert_id();
    }

     function agregar_actualizar_poliza_vehicular($params, $actualizar, $id)
    {
       	$this->db->trans_start();
		$id_insert = $this->db->insert('vehiculos_historial',$params);
		$this->db->where('id',$id);
		$this->db->update('vehiculos',$actualizar);
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)
		{
		        return 0;
		}

        return $id;
    }

      function agregar_actualizar_matafuego_vehicular($params, $actualizar, $id)
    {
       	$this->db->trans_start();
		$id_insert = $this->db->insert('vehiculos_historial',$params);
		$this->db->where('id',$id);
		$this->db->update('vehiculos',$actualizar);
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)
		{
		        return 0;
		}

        return $id;
    }

    function agregar_mantenimiento($params, $id)
     {

       	$nombre = $this->db->get_where('vehiculo_tipo_evento',array('id'=>$params['vehiculo_tipo_evento_id']))->row_array();
       	$params['descripcion'] = $nombre['nombre'];
       	$this->db->trans_start();
		$id_insert = $this->db->insert('vehiculos_historial',$params);
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)
		{
		        return 0;
		}

        return $id;
    }

       function agregar_actualizar_mantenimiento($params, $actualizar, $id)
    {
       	$this->db->trans_start();
		$id_insert = $this->db->insert('vehiculos_historial',$params);
		$this->db->where('id',$id);
		$this->db->update('vehiculos',$actualizar);
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)
		{
		        return 0;
		}

        return $id;
    }

    /*
     * function Acutalizar Vehiculo
     */
    function update_vehiculo($id,$params)
    {
        $this->db->where('id',$id);
        return $this->db->update('vehiculos',$params);
    }

      /*
     * Get all vehiculo
     */
    function get_vehiculo_historial_activo($id)
    {
        $this->db->order_by('fecha_desde', 'desc');
        return $this->db->get_where('vehiculos_historial',array('vehiculo_id'=>$id,'isDelete'=>0))->result_array();
    }

         /*
     * Get notas_Vehiculo
     */
    function get_vehiculo_historial($id)
    {
        $this->db->select('v.patente,
        					v.marca,
        					v.modelo,
        					v.anio,
        					vh.id,
        					vh.vehiculo_id,
        					vh.vehiculo_tipo_evento_id,
        					vh.fecha_desde,
        					vh.fecha_hasta,
        					vh.km,
        					vh.observacion
          					');
        $this->db->from('vehiculos_historial as vh');
        $this->db->join('vehiculos as v','vh.vehiculo_id = v.id');
    	$this->db->where('vh.id',  $id);
    	$this->db->where('vh.isDelete', 0);

        return $this->db->get()->row_array();

       // return $this->db->get_where('vehiculos_historial',array('id'=>$id))->row_array();
    }

     /*
     * function Acutalizar Vehiculo
     */
    function edit_historial($id,$params)
    {
        $this->db->where('id',$id);
        return $this->db->update('vehiculos_historial',$params);
    }

    function edit_vehiculo_historial($act_historial, $act_vehiculo, $id_historial, $vehiculo_id)
    {
       	$this->db->trans_start();
		$this->db->where('id',$id_historial);
        $this->db->update('vehiculos_historial',$act_historial);

		$this->db->where('id',$vehiculo_id);
		$this->db->update('vehiculos',$act_vehiculo);
		$this->db->trans_complete();

		if ($this->db->trans_status() === FALSE)
		{
		        return 0;
		}

        return $vehiculo_id;
    }

    /*




    */

     function get_vehiculo_ultimo_evento($tipo_evento_id)
    {

     if(($tipo_evento_id != 2) and ($tipo_evento_id != 5)){
     	$tipo_evento_id = 2;
     }

     $query = $this->db->query('Select
							    h.id,
							    h.vehiculo_id,
							    v.patente,
							    h.descripcion,
							    h.vehiculo_tipo_evento_id,
							    h.km,
							    h.fecha,
							    h.observacion,
							    h.fecha_hasta,
							    h.fecha_desde,
							    v.marca,
							    v.modelo
							From
    							vehiculos_historial h Inner Join
    							vehiculos v On v.id = h.vehiculo_id
								Where h.id = (select max(h1.id)
												from vehiculos_historial h1
												where h1.vehiculo_tipo_evento_id = '.$tipo_evento_id.'
															and h1.isDelete = 0
															and h.vehiculo_id = h1.vehiculo_id)
							 order by v.patente');
		return $query->result_array();

   }
}
