<?php
class VerOrdenCompras_model extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }

        /*
     * Get Orden de Compra
     */
    function get_ordendecompra($id)
    {
           $this->db->select('o.id,
         					o.fechaingreso,
						    o.area_id,
						    o.estado_id,
						    o.observaciones,
						    o.user_id,
						    o.created,
						    o.update,
						    o.anio,
						    a.title as area,
						    a.acodi as codiarea,
						    u.username,
						    e.title As estado,
						    e.color As estadoColor,
						    u.last_name,
    						u.first_name,
    						sum(i.importe) as totalorden
          					');
        $this->db->from('ordendecompras as o');
        $this->db->join('areas as a','a.id = o.area_id', 'left');
        $this->db->join('users as u','u.id = o.user_id', 'left');
        $this->db->join('ordenestados as e','e.id = o.estado_id', 'left');
        $this->db->join('ordendecompraitems as i','i.ordendecompra_id = o.id', 'left');
        $this->db->where('o.id',  $id);
        $this->db->group_by('o.id');


         return $this->db->get()->row_array();
    }

 	function get_all_ordendecompra($estado_id =0)
    {

         $this->db->select('o.id,
         					o.fechaingreso,
						    o.area_id,
						    o.estado_id,
						    o.observaciones,
						    o.user_id,
						    o.created,
						    o.update,
						    o.anio,
						    a.title as area,
						    a.acodi as codiarea,
						    u.username,
						    e.title As estado,
						    e.color As estadoColor,
						    u.last_name,
    						u.first_name,
    						sum(i.importe) as totalorden
          					');
        $this->db->from('ordendecompras as o');
        $this->db->join('areas as a','a.id = o.area_id', 'left');
        $this->db->join('users as u','u.id = o.user_id', 'left');
        $this->db->join('ordenestados as e','e.id = o.estado_id', 'left');
        $this->db->join('ordendecompraitems as i','i.ordendecompra_id = o.id', 'left');
        if ((is_numeric($estado_id)) &&($estado_id > 0)) {
        	 $this->db->where('o.estado_id',  $estado_id);
        }
        $this->db->group_by('o.id');
        $this->db->order_by('o.id', 'desc');
       return $this->db->get()->result_array();
    }

    function get_all_itemsordendecompra($id)
    {
         $this->db->select('*
          					');
        $this->db->from('ordendecompraitems as i');
        $this->db->where('i.ordendecompra_id',  $id);
        $this->db->where('i.isDelete',  0);
        $this->db->order_by('i.id', 'asc');
        return $this->db->get()->result_array();
    }

    function get_all_areas()
    {
        $this->db->select('*');
        $this->db->from('areas as a');
      //  $this->db->where('v.isDelete', 0);
        $this->db->order_by('a.title', 'asc');
        return $this->db->get()->result_array();
    }

     function get_all_productos()
    {
        $this->db->select('*');
        $this->db->from('productos as p');
      //  $this->db->where('v.isDelete', 0);
        $this->db->order_by('p.descripcion', 'asc');
        return $this->db->get()->result_array();
    }

     function get_producto($id)
    {
        $this->db->select('*');
        $this->db->from('productos as p');
        $this->db->where('p.id', $id);
        return $this->db->get()->row_array();
    }


    function get_ordendecompraitem($id)
    {
           $this->db->select('i.id,
							    i.ordendecompra_id,
							    i.producto_id,
							    i.producto_nombre,
							    i.producto_observacion,
							    i.cantidad,
							    i.importe,
							    i.created,
							    i.updated,
							    i.user_id,
							    i.isDelete,
							    i.deleteFecha,
							    o.estado_id
          					');
        $this->db->from('ordendecompraitems as i');
        $this->db->join('ordendecompras as o','i.ordendecompra_id = o.id');
        $this->db->where('i.id',  $id);
        return $this->db->get()->row_array();
    }

    function get_all_ordenestados()
    {
        $this->db->select('*');
        $this->db->from('ordenestados as o');
        $this->db->where('o.mostrarenseleccion', 1);
        $this->db->order_by('o.id', 'asc');
        return $this->db->get()->result_array();
    }

    function get_all_ordenHistorialEstado($id)
    {
       $this->db->select('h.id,
							h.ordendecompra_id,
							h.created,
							h.observaciones,
							h.estado_id,
							e.title as estadonombre,
							u.first_name,
							u.last_name
          					');
        $this->db->from('ordenhistorialestado as h');
        $this->db->join('ordenestados as e','e.id = h.estado_id');
        $this->db->join('users as u','u.id = h.user_id');
        $this->db->where('h.ordendecompra_id',  $id);
        $this->db->order_by('h.id', 'desc');
        return $this->db->get()->result_array();
    }

    function get_ordendecompraitem_actualizarstock($id)
    {
           $this->db->select('i.id,
							    i.ordendecompra_id,
							    i.producto_id,
							    p.stock,
							    i.cantidad
          					');
        $this->db->from('ordendecompraitems as i');
        $this->db->join('productos as p','p.id = i.producto_id');
        $this->db->where('i.ordendecompra_id',  $id);
        $this->db->where('p.permite_stock',  1);
        return $this->db->get()->result_array();
    }

     function get_busqueda_ordenestados()
    {
        $this->db->select('*');
        $this->db->from('ordenestados as o');
        $this->db->order_by('o.id', 'asc');
        return $this->db->get()->result_array();
    }

}
