<!-- Content Header (Page header) -->
<div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">Microbanco: Convocatorias</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="<?php echo base_url(); ?>">Proyectos</a></li>
              <li class="breadcrumb-item active">Microbanco</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->
<section class="content">
	<div class="container-fluid">
	      <div class="row">
          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-info">
              <div class="inner">
                <h3><?php if(isset($total_inscriptos)) { echo $total_inscriptos; } else { echo '0'; } ?></h3>

                <p>Total de Inscriptos</p>
              </div>
              <div class="icon">
                <i class="fas fa-id-card"></i>
              </div>
              <div class="small-box-footer" style="min-height: 40px;">
              	   <a href="<?php echo base_url('Microbanco/inscripciones/'); ?>" class="btn btn-sm bg-info float-left">M&aacute;s Info <i class="fas fa-arrow-circle-right"></i></a>

                   	   <a href="<?php echo base_url('Microbanco_resumen/'); ?>" class="btn btn-sm bg-info float-right">Resumen General <i class="fas fa-arrow-circle-right"></i></a>

               </div>
             </div>
          </div>
          <!-- ./col -->

            <?php foreach($convocatorias as $c){ ?>

	          <div class="col-lg-3 col-6">
	            <!-- small box -->
	            <div class="small-box <?php if(empty($c['color'])) { echo 'bg-white'; } else { echo $c['color']; } ?>">
	              <div class="inner">
	                <h3><?php if(isset($c['cantidad'])) { echo $c['cantidad']; } else { echo '0'; } ?></h3>

	                <p><?php echo $c['convocatoria'] ?></p>
	              </div>
	              <div class="icon">
	                <i class="fas <?php if(empty($c['icono'])) { echo 'fa-cog'; } else { echo $c['icono']; } ?>"></i>
	              </div>
	              <div class="small-box-footer" style="min-height: 40px;">
              	    <a href="<?php echo base_url('Microbanco/listado/'.$c['id']); ?>" class="btn btn-sm <?php if(empty($c['color'])) { echo 'bg-white'; } else { echo $c['color']; } ?> float-left">Listado <i class="fas fa-plus-circle"></i></a>

	              	<a href="<?php echo base_url('Microbanco/xestados/'.$c['id']); ?>" class="btn btn-sm <?php if(empty($c['color'])) { echo 'bg-white'; } else { echo $c['color']; } ?> float-center">X Situaci&oacute;n <i class="fas fa-plus-circle"></i></a>

	              	<a href="<?php echo base_url('Microbanco/xlocalidad/'.$c['id']); ?>" class="btn btn-sm <?php if(empty($c['color'])) { echo 'bg-white'; } else { echo $c['color']; } ?> float-right">X Localidad <i class="fas fa-plus-circle"></i></a>

              	  </div>

	           </div>
	          </div>

            <?php } ?>
          <!-- ./col -->
        </div>


        <div class="row">
          	<div class="col-12">
		         <div class="card card-success">
		              <div class="card-header">
		                <h3 class="card-title">Inscripciones por Convocatorias</h3>

		                <div class="card-tools">
		                  <button type="button" class="btn btn-tool" data-card-widget="collapse"><i class="fas fa-minus"></i></button>
		                </div>
		              </div>
		              <div class="card-body">
		                <div class="chart"><div class="chartjs-size-monitor"><div class="chartjs-size-monitor-expand"><div class=""></div></div><div class="chartjs-size-monitor-shrink"><div class=""></div></div></div>
		                  <canvas id="stackedBarChart" style="min-height: 250px; height: 400px; max-height: 400px; max-width: 100%; display: block; width: 487px;" width="487" height="400" class="chartjs-render-monitor"></canvas>
		                </div>
		              </div>
		              <!-- /.card-body -->
		            </div>
		     </div>
		 </div>
        <?php

?>
	</div>

 </section>

 <script>
  $(function () {
    var areaChartData = {
      labels  : [<?php echo $talabels;?>],
      datasets: [
        {
          label               : 'Convocatorias',
          backgroundColor     : [<?php echo $tascolor;?>],
          borderColor         : [<?php echo $tascolor;?>],
          pointRadius         : false,
          pointColor          : 'rgba(210, 214, 222, 1)',
          pointStrokeColor    : '#c1c7d1',
          pointHighlightFill  : '#fff',
          pointHighlightStroke: 'rgba(220,220,220,1)',
          data                :  [<?php echo $tasdata;?>]
        },
      ]
    }

    //---------------------
    //- STACKED BAR CHART -
    //---------------------
    var stackedBarChartCanvas = $('#stackedBarChart').get(0).getContext('2d')
    var stackedBarChartData = jQuery.extend(true, {}, areaChartData)

    var stackedBarChartOptions = {
      responsive              : true,
      maintainAspectRatio     : false,
      scales: {
        xAxes: [{
          stacked: true,
        }],
        yAxes: [{
          stacked: true
        }]
      }
    }

    var stackedBarChart = new Chart(stackedBarChartCanvas, {
      type: 'bar',
      data: stackedBarChartData,
      options: stackedBarChartOptions
    })
  })
</script>

